package com.oscar.base;

import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import javax.persistence.*;
import java.io.Serializable;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

@MappedSuperclass
@Data
public abstract class AbstractEntity<T> implements Serializable {
    private static final long serialVersionUID = 1L;

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Integer id;

    @JsonFormat(pattern = "yyyy-MM-dd HH:mm")        // 后台 -> page 的时间转换
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss") // page -> 后台 的时间转换
    @Column
    private Date createTime;

    @Transient
    Integer parentId;

    @Transient
    List<Integer> ids = new ArrayList<>(); //批量删除

    @Transient
    List<T> children = new ArrayList<>();

    @Transient
    String cnName;
}
