package com.oscar.base;

import com.oscar.base.util.SpringUtils;
import org.mybatis.spring.SqlSessionTemplate;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.NoRepositoryBean;


import java.util.List;

/**
 * jpa会将所有继承 Repository的类进行代理实例化，加上NoRepositoryBean注解就不会
 */
@NoRepositoryBean
public interface AbstractMapper<T extends AbstractEntity> extends JpaRepository<T,Integer> {
    // 可以不用写mapper.java
    SqlSessionTemplate template = SpringUtils.getBean(SqlSessionTemplate.class);

    /**
     * @Desc xml中的namespace随便写不重复就行，一般是包路径
     * @param statement xml文件中的名称（唯一）【namespace+id】
     */
    default List<T> selectList (String statement, T parameter) {
        return template.selectList(statement, parameter);
    }

    default List<T> selectList (String statement) {
        return template.selectList(statement);
    }

}
