package com.oscar.base.config;

import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.web.cors.CorsConfiguration;
import org.springframework.web.cors.UrlBasedCorsConfigurationSource;
import org.springframework.web.filter.CorsFilter;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

@Configuration
public class CorsConfig {
    @Bean
    public CorsFilter corsFilter() {

        final UrlBasedCorsConfigurationSource configSource = new UrlBasedCorsConfigurationSource();
        final CorsConfiguration config = new CorsConfiguration();

        List<String> all = Collections.singletonList("*");
        config.setAllowCredentials(true); // allow cookie cors
        config.setAllowedOrigins(all);
        config.setAllowedHeaders(all);
        config.setAllowedMethods(Arrays.asList("GET", "POST", "PUT", "DELETE"));
        config.setMaxAge(3600L);

        configSource.registerCorsConfiguration("/**", config);
        return new CorsFilter(configSource);
    }
}
