package com.oscar.base.util;

import org.springframework.beans.BeanWrapper;
import org.springframework.beans.BeanWrapperImpl;

import java.lang.reflect.Field;
import java.util.Map;
import java.util.Set;
import java.util.stream.Collectors;
import java.util.stream.Stream;

public class BeanUtils {
    public static <T> T map2Bean (Map<String, Object> map, Class<T> clazz) throws Exception {
        T obj = clazz.newInstance();
        if (map.isEmpty())
            return obj;

        BeanWrapper beanWrapper = new BeanWrapperImpl(obj);

        Set<String> fieldSet = Stream.of(clazz.getDeclaredFields())
                .map(Field::getName)
                .collect(Collectors.toSet());

        fieldSet.addAll(Stream.of(clazz.getSuperclass().getDeclaredFields())
                .map(Field::getName)
                .collect(Collectors.toSet()));

        for (Map.Entry<String, Object> entry : map.entrySet())
            if (fieldSet.contains(entry.getKey()))
                beanWrapper.setPropertyValue(entry.getKey(), entry.getValue());
        return obj;
    }
}
