package com.oscar.base.util;

import com.itextpdf.text.Chunk;
import com.itextpdf.text.Document;
import com.itextpdf.text.Font;
import com.itextpdf.text.Paragraph;
import com.itextpdf.text.pdf.BaseFont;
import com.itextpdf.text.pdf.PdfWriter;

import java.io.FileOutputStream;

/**
 * Desc :
 *
 * @author wl
 * Date:    2019/3/26 14:02
 * @version 1.0
 */
@SuppressWarnings({"unused"})
public class PDFUtils {
    public static void create (String title, String content, String out) throws Exception {
        PDF pdf = new PDF();
        pdf.title = title;
        pdf.content = content;
        pdf.out = out;
        create(pdf);
    }

    public static void create (PDFUtils.PDF pdf) throws Exception {
        BaseFont bf = BaseFont.createFont("C:/WINDOWS/Fonts/SIMYOU.TTF", BaseFont.IDENTITY_H, BaseFont.NOT_EMBEDDED);
        Font headFont = new Font(bf, 28, Font.BOLD);
        Font textFont = new Font(bf, 14);

        Document document = new Document();
        PdfWriter writer = PdfWriter.getInstance(document, new FileOutputStream(pdf.out));
        writer.setPdfVersion(PdfWriter.PDF_VERSION_1_7);
        writer.setViewerPreferences(PdfWriter.DisplayDocTitle);
        document.addTitle(pdf.title);
        writer.createXmpMetadata();

        document.open();
        Paragraph title = new Paragraph();
        title.setFont(headFont);
        title.add(new Chunk(pdf.title));
        document.add(title);

        Paragraph p = new Paragraph();
        p.setFont(textFont);
        p.add(new Chunk(pdf.content));
        document.add(p);

        document.close();
    }

    static class PDF {
        String out;
        String title;
        String content;//正文
    }
}
