package com.oscar.base.vo;

import java.util.List;

@SuppressWarnings({"unused"})
public class ResultVO<E> {
    private Integer code;
    private String type;
    private String message;
    private Object data;

    public String getType () {
        return type;
    }

    public void setType (String type) {
        this.type = type;
    }

    public String getMessage () {
        return message;
    }

    public void setMessage (String message) {
        this.message = message;
    }

    public Integer getCode () {
        return code;
    }

    public void setCode (Integer code) {
        this.code = code;
    }

    public Object getData () {
        return data;
    }

    public void setData (Object data) {
        this.data = data;
    }

    public static ResultVO success (Object object) {
        final ResultVO vo = success();
        vo.setData(object);
        return vo;
    }
    public static ResultVO success () {
        ResultVO ow = new ResultVO();
        ow.setCode(0);
        ow.setType("success");
        ow.setMessage("操作成功");
        return ow;
    }

    public static ResultVO warn (String message) {
        ResultVO ow = new ResultVO();
        ow.setCode(1);
        ow.setType("warning");
        ow.setMessage(message);
        return ow;
    }

    public static ResultVO timeout (String message) {
        ResultVO ow = new ResultVO();
        ow.setCode(-1);
        ow.setType("error");
        ow.setMessage(message);
        return ow;
    }

    public static ResultVO error (String message) {
        ResultVO ow = new ResultVO();
        ow.setCode(2);
        ow.setType("error");
        ow.setMessage(message);
        return ow;
    }

    public ResultVO setList (List<E> list) {
        setData(list);
        return this;
    }

    public ResultVO set (E t) {
        setData(t);
        return this;
    }
}
