package com.oscar.gen;


import com.oscar.base.AbstractEntity;
import com.oscar.gen.android.Android;
import com.oscar.gen.express.Express;
import com.oscar.gen.vue.Vue;
import com.oscar.gen.vux.Vux;
import com.oscar.gen.wechat.Wechat;
import lombok.Data;

import javax.persistence.Entity;
import javax.persistence.Transient;
import java.util.List;

@Entity
@Data
public class CodeGen extends AbstractEntity<CodeGen> {
    String root; //根目录 D:/IdeaProjects/private_job/2019/wx_study_online

    String projectName; //学习凭条
    String moduleName;//studyonline

    String schema;
    String tableName;//tb_oscar_info

    @Transient List<Column> columns;
    @Transient List<Column> columnsWithoutId; //同columns，把id主键字段去掉
    @Transient Column primaryKey;
    String className; //TbOscarInfo
    String projectPath;
    String packageName;
    String requestUri; // /tb/oscar/info
    String entityVar;  // tbOscarInfo

    boolean hasUserIdColumn = false;//是否join sys_user表获取cn_name名称
    boolean hasStateColumn = false; //是否有审核字段

    //vue template config
    @Transient Option option;
    @Transient Vue vue;
    @Transient Vux vux;
    @Transient Wechat wechat;
    @Transient Express express;
    public @Transient Android android;

    public boolean styleUpdate; //是否更新风格
    @Transient PageStyle pageStyle;//解析后的css对象
    String css;  //未解析的css

    String sql;
}
