package com.oscar.gen;

import cn.hutool.core.util.StrUtil;
import com.oscar.base.AbstractService;
import com.oscar.base.util.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
public class CodeGenService extends AbstractService<CodeGenMapper, CodeGen> {
    List<Column> schemaList(){
        return  dao.schemaList();
    }
    List<Column> tableList(Column param){
        return dao.tableList(param);
    }
    public List<Column> fetchColumns (CodeGen codeGen) {
        Column column = new Column();
        column.setTableSchema(codeGen.getSchema());
        column.setTableName(codeGen.getTableName());

        List<Column> list = dao.findList(column);
        list.forEach(x -> {
            System.out.println(x);
            switch (x.getDataType()) {
                case "varchar":
                case "longblob":
                case "text":
                case "char":
                    x.setDataType("String");
                    break;
                case "tinyint":
                case "bigint":
                case "number":
                case "int":
                    x.setDataType("Integer");
                    break;
                case "datetime":
                case "timestamp":
                case "date":
                    x.setDataType("Date");
                    break;
                case "double":
                case "decimal":
                    x.setDataType("Double");
                    break;
                default:
                    break;
            }

            final String capitalizeCamelCase = StringUtils.toCapitalizeCamelCase(x.getColumnName());
            x.setField(StrUtil.toCamelCase(x.getColumnName()));
            x.setCapField(capitalizeCamelCase);
            x.setGetter("get"+ capitalizeCamelCase);
            x.setSetter("set"+ capitalizeCamelCase);

            if("PRI".equalsIgnoreCase(x.getColumnKey())){
                codeGen.setPrimaryKey(x);
            }
        });
        return list;
    }

}
