package com.oscar.gen;

import com.oscar.base.AbstractEntity;
import lombok.Data;

import javax.persistence.Entity;

@Entity
@Data
public class Column extends AbstractEntity {
    String tableSchema;
    String tableName;
    String tableComment;//表备注
    String columnName=""; //create_time 数据库字段
    String columnKey;
    String columnComment; //创建时间
    String dataType; //String Integer Date Double
    String inputType;//表单类型，如电话号，密码，图片，等，展示不同
    String isNullable; //YES NO
    String extra;

    String field; //createTime java字段
    String capField; //首字母大写 CreateTime
    String getter;//getCreateTime getter方法
    String setter;//setCreateTime setter方法

    String tableClassify = "tb_";//表分类，tbl_开头或者sys_开头

    boolean dict;  //字段是_type结尾的，页面以下拉框展示
    boolean rating;//是否有rating开头的，页面显示评分组件
    public boolean isDict () {
        return this.columnName.endsWith("_type") || this.columnName.equals("type");
    }
    public boolean isRating () {
        return this.columnName.startsWith("rating");
    }

    @Override
    public String toString () {
        return "Column{" +
                "tableSchema='" + tableSchema + '\'' +
                ", tableName='" + tableName + '\'' +
                ", tableComment='" + tableComment + '\'' +
                ", columnName='" + columnName + '\'' +
                ", columnKey='" + columnKey + '\'' +
                ", columnComment='" + columnComment + '\'' +
                ", dataType='" + dataType + '\'' +
                ", inputType='" + inputType + '\'' +
                ", isNullable='" + isNullable + '\'' +
                ", extra='" + extra + '\'' +
                ", field='" + field + '\'' +
                ", getter='" + getter + '\'' +
                ", setter='" + setter + '\'' +
                '}';
    }
}
