package com.oscar.gen.springboot;

import cn.hutool.extra.template.TemplateException;
import com.oscar.gen.CodeGen;
import com.oscar.gen.FreeMarkerUtils;

import java.io.IOException;


public class SpringBootGen {
    public static void gen (CodeGen codeGen) throws IOException, TemplateException, freemarker.template.TemplateException {
        if(!codeGen.getOption().java){
           return;
        }

        String s = codeGen.getPackageName().replaceAll("\\.","/");
        String src = codeGen.getRoot() + "/java/src/main/java/" + s + "/";
        String fileName = codeGen.getClassName();
        FreeMarkerUtils.gen(src, fileName, codeGen, "springboot/dao.ftl", "Mapper.java");
        FreeMarkerUtils.gen(src, fileName, codeGen, "springboot/entity.ftl", ".java");
        FreeMarkerUtils.gen(src, fileName, codeGen, "springboot/service.ftl", "Service.java");
        FreeMarkerUtils.gen(src, fileName, codeGen, "springboot/controller.ftl", "Controller.java");
        FreeMarkerUtils.gen(src, fileName, codeGen, "springboot/mapper.ftl", "Mapper.xml");
    }
}
