package com.oscar.gen.vue;

import cn.hutool.extra.template.TemplateException;
import com.oscar.gen.CodeGen;
import com.oscar.gen.FreeMarkerUtils;

import java.io.IOException;

public class VueGen {
    public static void gen (CodeGen codeGen) throws IOException, TemplateException, freemarker.template.TemplateException {
        if(!codeGen.getOption().vue){
            //不需要生成vue代码
            return;
        }

        if(!codeGen.getVue().isDetail()){
            codeGen.getVue().setDetailFlag("hide");
        }
        if (!codeGen.getVue().isAdd()) {
            codeGen.getVue().setAddFlag("hide");
        }
        if (!codeGen.getVue().isDelete()) {
            codeGen.getVue().setDeleteFlag("hide");
        }
        if (!codeGen.getVue().isUpdate()) {
            codeGen.getVue().setUpdateFlag("hide");
        }

        FreeMarkerUtils.gen(codeGen.getVue().getFilePath(), codeGen.getVue().getFileName(), codeGen, "vue/vue-page.ftl", ".vue");
        FreeMarkerUtils.refreshRouter(codeGen, codeGen.getVue().getFileName());
    }
}
