package com.oscar.module.cms.info;

import com.oscar.base.AbstractEntity;
import com.oscar.module.cms.reply.TbCmsReply;
import lombok.Data;

import javax.persistence.Entity;
import javax.persistence.Transient;
import java.util.ArrayList;
import java.util.List;

@Entity
@Data
public class TbCmsInfo extends AbstractEntity<TbCmsInfo> {
    String type;
    String category;
    Integer praise;  //点赞数
    Integer forward; //转发数
    Integer favorite; //收藏数
    boolean inMyFavorite = false; //是否在我的收藏
    boolean hasPraised = false; //是否已经点赞了
    Integer replyNum; //评论数
    String openid;
    String headPhoto;

    @Transient
    List<TbCmsReply> replyList = new ArrayList<>();

    String fromFavorite; // favorite：从我的收藏发的请求，为空，则正常请求新闻资讯内容
    Integer userId;
    String state;
    boolean disabled;

    public Integer getReplyNum() {
        return replyList.size();
    }
}
