package com.oscar.module.cms.notice;

import com.github.pagehelper.PageInfo;
import com.oscar.base.AbstractController;
import com.oscar.base.enums.CssStyleTypeEnum;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;

@RestController
@RequestMapping("/tb/cms/notice")
public class TbCmsNoticeController extends AbstractController<TbCmsNoticeService, TbCmsNotice>{

    @GetMapping("advance/page")
    public PageInfo<TbCmsNotice> advancePageList (HttpServletRequest request, TbCmsNotice tbCmsNotice) {
        PageInfo<TbCmsNotice> pageInfo = service.pageList(request, tbCmsNotice);

        for (TbCmsNotice x : pageInfo.getList()) {
            if("未审核".equals(x.getState())){
                x.setType(CssStyleTypeEnum.warning.getText());
            }else if("审核通过".equals(x.getState())){
                x.setDisabled(true);
                x.setType(CssStyleTypeEnum.success.getText());
            }else if("驳回".equals(x.getState())){
                x.setDisabled(true);
                x.setType(CssStyleTypeEnum.danger.getText());
            }
        }
        return pageInfo;
    }

}
