package com.oscar.module.cms.reply;

import cn.hutool.core.date.DateUnit;
import cn.hutool.core.date.DateUtil;
import com.oscar.base.AbstractEntity;
import lombok.Data;

import javax.persistence.Entity;
import java.util.Date;

@Entity
@Data
public class TbCmsReply extends AbstractEntity<TbCmsReply> {
    Integer cmsId;
    String source;
    Integer praise;
    String openid;
    String headPhoto;

    String type;
    String state;
    boolean disabled;

    String elapsedTime;

    public String getElapsedTime(){
        if(getCreateTime() == null){
            return "";
        }
        long diff = DateUtil.between(getCreateTime(), new Date(), DateUnit.SECOND);
        if (diff < 30) {
            return "刚刚";
        } else if (diff < 3600) { // less 1 hour
            return Math.round(diff / 60) + "分钟前";
        } else if (diff < 3600 * 24) {
            return Math.round(diff / 3600) + "小时前";
        } else if (diff < 3600 * 24 * 2) {
            return "1天前";
        } else {
            return DateUtil.formatDateTime(getCreateTime());
        }
    }
}
