package com.oscar.module.cms.reply;

import com.github.pagehelper.PageInfo;
import com.oscar.base.AbstractController;
import com.oscar.base.enums.CssStyleTypeEnum;
import com.oscar.base.vo.ResultVO;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;

@RestController
@RequestMapping("/tb/cms/reply")
public class TbCmsReplyController extends AbstractController<TbCmsReplyService, TbCmsReply>{

    @GetMapping("advance/page")
    public PageInfo<TbCmsReply> advancePageList (HttpServletRequest request, TbCmsReply tbCmsReply) {
        PageInfo<TbCmsReply> pageInfo = service.pageList(request, tbCmsReply);

        for (TbCmsReply x : pageInfo.getList()) {
            if("未审核".equals(x.getState())){
                x.setType(CssStyleTypeEnum.warning.getText());
            }else if("审核通过".equals(x.getState())){
                x.setDisabled(true);
                x.setType(CssStyleTypeEnum.success.getText());
            }else if("驳回".equals(x.getState())){
                x.setDisabled(true);
                x.setType(CssStyleTypeEnum.danger.getText());
            }
        }
        return pageInfo;
    }

    @PostMapping("fresh")
    public ResultVO fresh (@RequestBody TbCmsReply tbCmsReply) {
        service.save(tbCmsReply);

        TbCmsReply query = new TbCmsReply();
        query.setCmsId(tbCmsReply.getCmsId());
        return success(service.findList(query));
    }

}
