package com.oscar.module.favorite;

import com.github.pagehelper.PageInfo;
import com.oscar.base.AbstractController;
import com.oscar.base.enums.CssStyleTypeEnum;
import com.oscar.base.vo.ResultVO;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;

@RestController
@RequestMapping("/tb/cms/favorite")
public class TbCmsFavoriteController extends AbstractController<TbCmsFavoriteService, TbCmsFavorite>{

    @GetMapping("advance/page")
    public PageInfo<TbCmsFavorite> advancePageList (HttpServletRequest request, TbCmsFavorite tbCmsFavorite) {
        PageInfo<TbCmsFavorite> pageInfo = service.pageList(request, tbCmsFavorite);

        for (TbCmsFavorite x : pageInfo.getList()) {
            if("未审核".equals(x.getState())){
                x.setType(CssStyleTypeEnum.warning.getText());
            }else if("审核通过".equals(x.getState())){
                x.setDisabled(true);
                x.setType(CssStyleTypeEnum.success.getText());
            }else if("驳回".equals(x.getState())){
                x.setDisabled(true);
                x.setType(CssStyleTypeEnum.danger.getText());
            }
        }
        return pageInfo;
    }

    @DeleteMapping("cancel")
    public ResultVO cancelFavorite (@RequestBody TbCmsFavorite tbCmsFavorite) {
        service.cancelFavorite(tbCmsFavorite);
        return success();
    }

}
