package com.oscar.module.location;

import com.oscar.base.AbstractService;
import org.springframework.stereotype.Service;

@Service
public class TbLocationService extends AbstractService<TbLocationMapper,TbLocation> {
    public double getDistance(Double lat1,Double lng1,Double lat2,Double lng2) {
        // 经纬度（角度）转弧度。弧度用作参数，以调用Math.cos和Math.sin
        double radiansAX = Math.toRadians(lng1); // A经弧度
        double radiansAY = Math.toRadians(lat1); // A纬弧度
        double radiansBX = Math.toRadians(lng2); // B经弧度
        double radiansBY = Math.toRadians(lat2); // B纬弧度

        // 公式中“cosβ1cosβ2cos（α1-α2）+sinβ1sinβ2”的部分，得到∠AOB的cos值
        double cos = Math.cos(radiansAY) * Math.cos(radiansBY) * Math.cos(radiansAX - radiansBX)
                + Math.sin(radiansAY) * Math.sin(radiansBY);
        //        System.out.println("cos = " + cos); // 值域[-1,1]
        double acos = Math.acos(cos); // 反余弦值
        //        System.out.println("acos = " + acos); // 值域[0,π]
        //        System.out.println("∠AOB = " + Math.toDegrees(acos)); // 球心角 值域[0,180]
        return 6378137 * acos; // 最终结果
    }
}
