package com.oscar.module.mall.category;

import com.github.pagehelper.PageInfo;
import com.oscar.base.AbstractController;
import com.oscar.base.enums.CssStyleTypeEnum;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;

@RestController
@RequestMapping("/tb/product/category")
public class TbProductCategoryController extends AbstractController<TbProductCategoryService, TbProductCategory>{

    @GetMapping("advance/page")
    public PageInfo<TbProductCategory> advancePageList (HttpServletRequest request, TbProductCategory tbProductCategory) {
        PageInfo<TbProductCategory> pageInfo = service.pageList(request, tbProductCategory);

        for (TbProductCategory x : pageInfo.getList()) {
            if("未审核".equals(x.getState())){
                x.setType(CssStyleTypeEnum.warning.getText());
            }else if("审核通过".equals(x.getState())){
                x.setDisabled(true);
                x.setType(CssStyleTypeEnum.success.getText());
            }else if("驳回".equals(x.getState())){
                x.setDisabled(true);
                x.setType(CssStyleTypeEnum.danger.getText());
            }
        }
        return pageInfo;
    }

}
