package com.oscar.module.mall.order;

import cn.hutool.core.date.DateUtil;
import cn.hutool.core.util.RandomUtil;
import com.github.pagehelper.PageInfo;
import com.oscar.base.AbstractController;
import com.oscar.base.vo.ResultVO;
import com.oscar.sys.GlobalData;
import com.oscar.sys.dict.SysDictService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;
import java.util.Date;
import java.util.List;

@RestController
@RequestMapping("/tb/order")
public class TbOrderController extends AbstractController<TbOrderService, TbOrder> {
    @Autowired
    SysDictService sysDictService;

    private void idToName (List<TbOrder> list) {
        for (TbOrder tbOrder : list) {
            tbOrder.setOrderTypeLabel(sysDictService.getLabel("order_type", tbOrder.getOrderType()));
            tbOrder.setOrderStatusLabel(sysDictService.getLabel("order_status", tbOrder.getOrderStatus()));
            tbOrder.setPayStatusLabel(sysDictService.getLabel("pay_status", tbOrder.getPayStatus()));
            tbOrder.setSysUser(GlobalData.getSysUser(tbOrder.getUserId()));
        }
    }

    @Override
    public PageInfo<TbOrder> pageList (HttpServletRequest request, TbOrder tbOrder) {
        final PageInfo<TbOrder> info = service.pageList(request, tbOrder);
        idToName(info.getList());
        return info;
    }

    @Override
    public ResultVO save (TbOrder tbOrder) {
        if(tbOrder.getId() == null){
            tbOrder.setNo(DateUtil.format(new Date(),"yyyyMMddHHmmss")+ RandomUtil.randomInt(100,999));
        }
        service.save(tbOrder);
        return success();
    }

}
