package com.oscar.module.mall.product;

import com.oscar.base.AbstractController;
import com.oscar.base.util.IdGen;
import com.oscar.base.vo.ResultVO;
import org.springframework.web.bind.annotation.*;

import java.util.List;

@RestController
@RequestMapping("/tb/product")
public class TbProductController extends AbstractController<TbProductService, TbProduct> {

    @GetMapping("info/count")
    public ResultVO stat (TbProduct tbProduct) {
        final List<TbProduct> list = service.findList(tbProduct);
        class S{
            private int online = 0;
            private int offline = 0;
            private int stock_normal = 0;
            private int stock_low = 0;
            private int stock_empty = 0;
            private int trash = 0;
        }
        S s = new S();

        for (TbProduct x : list) {
            if ("ON".equals(x.getStatus())) {
                s.online++;
            } else if ("OFF".equals(x.getStatus())) {
                s.offline++;
            } else if ("TRASH".equals(x.getStatus())) {
                s.trash++;
            }
            if (x.getStock() == 0) {
                s.stock_empty++;
            } else if (x.getStock() < 6) {
                s.stock_low++;
            } else {
                s.stock_normal++;
            }
        }
        return ResultVO.success(s);
    }

    @Override
    public ResultVO save (TbProduct tbProduct) {
        tbProduct.setProductId(IdGen.next());
        service.save(tbProduct);
        return success();
    }

    @PostMapping("changeStatus")
    public ResultVO changeStatus (@RequestBody TbProduct tbProduct) {
        service.changeStatus(tbProduct);
        return success();
    }

}
