package com.oscar.module.wenjuan;

import com.github.pagehelper.PageInfo;
import com.oscar.base.AbstractController;
import com.oscar.base.enums.CssStyleTypeEnum;
import com.oscar.base.vo.ResultVO;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import java.util.List;
import java.util.stream.Collectors;

@RestController
@RequestMapping("/tb/wenjuan")
public class TbWenjuanController extends AbstractController<TbWenjuanService, TbWenjuan>{

    @GetMapping("advance/page")
    public PageInfo<TbWenjuan> advancePageList (HttpServletRequest request, TbWenjuan tbWenjuan) {
        PageInfo<TbWenjuan> pageInfo = service.pageList(request, tbWenjuan);

        for (TbWenjuan x : pageInfo.getList()) {
            if("未审核".equals(x.getState())){
                x.setType(CssStyleTypeEnum.warning.getText());
            }else if("审核通过".equals(x.getState())){
                x.setDisabled(true);
                x.setType(CssStyleTypeEnum.success.getText());
            }else if("驳回".equals(x.getState())){
                x.setDisabled(true);
                x.setType(CssStyleTypeEnum.danger.getText());
            }
        }
        return pageInfo;
    }

    @DeleteMapping("batch")
    public ResultVO batchDelete (@RequestBody TbWenjuan tbWenjuan) {
        List<TbWenjuan> collect = tbWenjuan.getIds().stream().map(id -> {
            TbWenjuan o = new TbWenjuan();
            o.setId(id);
            return o;
        }).collect(Collectors.toList());
        service.batchDelete(collect);
        return success();
    }

}
