package com.oscar.module.wenjuan;

import com.github.pagehelper.PageInfo;
import com.oscar.base.AbstractController;
import com.oscar.base.enums.CssStyleTypeEnum;
import com.oscar.base.vo.ResultVO;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import java.util.List;
import java.util.stream.Collectors;

@RestController
@RequestMapping("/tb/wenjuan/record")
public class TbWenjuanRecordController extends AbstractController<TbWenjuanRecordService, TbWenjuanRecord>{

    @GetMapping("advance/page")
    public PageInfo<TbWenjuanRecord> advancePageList (HttpServletRequest request, TbWenjuanRecord tbWenjuanRecord) {
        PageInfo<TbWenjuanRecord> pageInfo = service.pageList(request, tbWenjuanRecord);

        for (TbWenjuanRecord x : pageInfo.getList()) {
            if("未审核".equals(x.getState())){
                x.setType(CssStyleTypeEnum.warning.getText());
            }else if("审核通过".equals(x.getState())){
                x.setDisabled(true);
                x.setType(CssStyleTypeEnum.success.getText());
            }else if("驳回".equals(x.getState())){
                x.setDisabled(true);
                x.setType(CssStyleTypeEnum.danger.getText());
            }
        }
        return pageInfo;
    }

    @DeleteMapping("batch")
    public ResultVO batchDelete (@RequestBody TbWenjuanRecord tbWenjuanRecord) {
        List<TbWenjuanRecord> collect = tbWenjuanRecord.getIds().stream().map(id -> {
            TbWenjuanRecord o = new TbWenjuanRecord();
            o.setId(id);
            return o;
        }).collect(Collectors.toList());
        service.batchDelete(collect);
        return success();
    }

}
