package com.oscar.sys;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Configuration;
import org.springframework.http.HttpHeaders;

import javax.servlet.*;
import javax.servlet.annotation.WebFilter;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.Arrays;
import java.util.HashSet;
import java.util.Set;

@Configuration
@WebFilter(urlPatterns = "/*")
public class RequestFilter implements Filter {
    @Autowired
    SessionProvider sessionProvider;

    private static final Set<String> EXCLUDES = new HashSet<>(Arrays.asList("/", "/error", "/login", "/logout"));

    @Override
    public void init (FilterConfig filterConfig) throws ServletException {

    }

    public static String getToken (HttpServletRequest request) {
        return request.getHeader(HttpHeaders.AUTHORIZATION);
    }

    @Override
    public void doFilter (ServletRequest servletRequest, ServletResponse servletResponse, FilterChain filterChain) throws IOException, ServletException {
        HttpServletRequest request = (HttpServletRequest) servletRequest;
        HttpServletResponse response = (HttpServletResponse) servletResponse;
        String path = request.getRequestURI().substring(request.getContextPath().length()).replaceAll("[/]+$", "");

        if (EXCLUDES.contains(request.getRequestURI()) || 1 == 1) {
            filterChain.doFilter(servletRequest, servletResponse);
        } else {
            if (sessionProvider.isValid(getToken(request))) {
                filterChain.doFilter(servletRequest, servletResponse);
            } else {
                request.getRequestDispatcher("/timeout").forward(servletRequest, servletResponse);
            }
        }
    }

    @Override
    public void destroy () {

    }
}
