package com.oscar.sys;

import com.oscar.base.AbstractEntity;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

public class TreeFactory {
    public static List<Map<String, Object>> buildLM (List<Map<String, Object>> list) {
        List<Map<String, Object>> data = new ArrayList<>();
        for (Map<String, Object> n : list) {
            if ("0".equals(String.valueOf(n.get("parentId")))) {
                data.add(findLMChild(n, list));
            }
        }
        return data;
    }

    private static Map<String, Object> findLMChild (Map<String, Object> parent, List<Map<String, Object>> list) {
        for (Map<String, Object> n : list) {
            if (parent.get("id").equals(n.get("parentId"))) {
                List children = (List)parent.get("children");
                if(children == null)
                    children = new ArrayList();
                children.add(findLMChild(n, list));
                parent.put("children",children);
            }
        }
        return parent;
    }

    public static List build (List<? extends AbstractEntity> list) {
        List<AbstractEntity> data = new ArrayList<>();
        for (AbstractEntity n : list) {
            if (n.getParentId() == 0 || n.getParentId() == -1) { //从一级菜单开始递归，或者回到首页的menu
                data.add(findChild(n, list));
            }
        }
        return data;
    }

    private static AbstractEntity findChild (AbstractEntity parent, List<? extends AbstractEntity> list) {
        for (AbstractEntity n : list) {
            if (parent.getId().equals(n.getParentId())) {
                parent.getChildren().add(findChild(n, list));
            }
        }
        return parent;
    }
}
