package com.oscar.sys.desc;

import com.oscar.base.AbstractController;
import com.oscar.base.config.ConfigSysProperties;
import com.oscar.base.vo.ResultVO;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

@RestController
@RequestMapping("/sys/desc")
public class SysDescController extends AbstractController<SysDescService, SysDesc> {
    @Autowired
    ConfigSysProperties config;

    @Value("${spring.application.name:OSCAR}")
    private String applicationName;
    @Value("${mybatis.type-aliases-package:com.jlt}")
    private String packageRootName;

    @GetMapping("test")
    public String test (String signature, String timestamp, String nonce, String echostr) {
        return echostr;
    }

    @GetMapping()
    public ResultVO findObject (SysDesc sysDesc) {
        SysDesc result = service.get(sysDesc).orElse(new SysDesc());
        result.setSchema(applicationName); //same between scheme and application name
        result.setPackageName(packageRootName + "." + config.getPackageModuleName());
        result.setProjectPath(config.getUploadPath().replaceAll("assets/", ""));
        result.setModuleName(config.getPackageModuleName());
        return success(result);
    }

}
