package com.oscar.sys.dict;

import com.oscar.base.AbstractController;
import com.oscar.base.vo.ResultVO;
import org.springframework.beans.BeanUtils;
import org.springframework.web.bind.annotation.*;

import java.util.ArrayList;
import java.util.List;
import java.util.stream.Collectors;

@RestController
@RequestMapping("/sys/dict")
public class SysDictController extends AbstractController<SysDictService, SysDict> {

    @PostMapping("batch")
    public ResultVO batchSave (@RequestBody SysDict sysDict) {
        final String[] split = sysDict.getLabel().split("#");
        List<SysDict> list = new ArrayList<>();
        Integer sort = 10; //初始顺序值
        for (String label : split) {
            SysDict target = new SysDict();
            BeanUtils.copyProperties(sysDict, target);
            target.setLabel(label);
            target.setValue(label);
            target.setSort(sort);
            sort += 10;
            list.add(target);
        }
        service.batchInsert(list);
        return success();
    }

    @DeleteMapping("batch")
    public ResultVO batchDelete (@RequestBody SysDict sysDict) {
        List<SysDict> collect = sysDict.getIds().stream().map(id -> {
            SysDict o = new SysDict();
            o.setId(id);
            return o;
        }).collect(Collectors.toList());
        service.batchDelete(collect);
        return success();
    }

}
