package com.oscar.sys.dict;

import com.oscar.base.AbstractService;
import org.springframework.stereotype.Service;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

@Service
public class SysDictService extends AbstractService<SysDictMapper, SysDict> {
    public static final Map<String, String> dict = new HashMap<>();

    private void init () {
        if (dict.isEmpty()) {
            List<SysDict> all = dao.findAll();
            all.forEach(x -> dict.put(x.getType() + "-" + x.getValue(), x.getLabel()));
        }
    }

    /**
     * 获取label 通过type-value
     */
    public String getLabel (String type, String value) {
        init();
        String label = dict.get(type + "-" + value);
        if (label == null) {
            label = "未配置";
        }
        return label;
    }
}
