package com.oscar.sys.role;

import com.github.pagehelper.PageInfo;
import com.oscar.base.AbstractController;
import com.oscar.base.vo.ResultVO;
import com.oscar.sys.rolemenu.SysRoleMenu;
import com.oscar.sys.rolemenu.SysRoleMenuService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;

@RestController
@RequestMapping("/sys/role")
public class SysRoleController extends AbstractController<SysRoleService, SysRole> {
    @Autowired
    SysRoleMenuService sysRoleMenuService;

    @GetMapping("all")
    public PageInfo<SysRole> findRoleMenuList (HttpServletRequest request, SysRole sysRole) {
        return service.findRoleMenuList(request, sysRole);
    }

    @Override
    public ResultVO save (SysRole sysRole) {
        service.save(sysRole);

        SysRoleMenu roleMenu = new SysRoleMenu();
        roleMenu.setRoleId(sysRole.getId());
        sysRoleMenuService.deleteByRoleId(roleMenu);

        if(sysRole.getMenuIds() != null){
            sysRole.getMenuIds().forEach(menuId->{
                roleMenu.setMenuId(menuId);
                sysRoleMenuService.save(roleMenu);
            });
        }
        return success();
    }

    @Override
    public ResultVO delete (SysRole sysRole) {
        service.delete(sysRole);
        SysRoleMenu roleMenu = new SysRoleMenu();
        roleMenu.setRoleId(sysRole.getId());
        sysRoleMenuService.deleteByRoleId(roleMenu);
        return success();
    }
}
