package com.oscar.sys.user;

import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import com.oscar.base.AbstractService;
import com.oscar.sys.SessionProvider;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import javax.servlet.http.HttpServletRequest;
import java.util.List;

@Service
public class SysUserService extends AbstractService<SysUserMapper,SysUser> {
    @Autowired
    SessionProvider sessionProvider;

    public void save(SysUser sysUser){
        sessionProvider.encrypt(sysUser);
        super.save(sysUser);
    }
    public void modify(SysUser sysUser){
        super.save(sysUser);
    }

    public PageInfo<SysUser> findUserRoleList (HttpServletRequest request, SysUser entity) {
        Integer pageNum = Integer.parseInt(request.getParameter("pageNum"));
        Integer pageSize = Integer.parseInt(request.getParameter("pageSize"));
        PageHelper.startPage(pageNum, pageSize);
        List<SysUser> list = dao.findUserRoleList(entity);
        mergeRole(list);
        return new PageInfo<>(list);
    }

    public List<SysUser> findUserRoleList(SysUser entity){
        List<SysUser> list = dao.findUserRoleList(entity);
        mergeRole(list);
        return list;
    }

    private void mergeRole (List<SysUser> list) {
        list.forEach(data->{
            if(data.getRoleIdsStr() != null){
                String[] split = data.getRoleIdsStr().split(",");
                for(String role : split){
                    data.setRoleId(Integer.parseInt(role));
                    data.getRoleIds().add(Integer.parseInt(role));
                }
            }
        });
    }
}
