package ${android.packageName};

import android.content.Context;
import android.support.v7.widget.RecyclerView;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageView;
import android.widget.TextView;
import com.bumptech.glide.Glide;
import com.oscar.R;
import com.oscar.base.Constant;
import com.oscar.base.listener.OnItemClickListener;


import java.io.File;
import java.util.List;

public class ${className}Adapter extends RecyclerView.Adapter<${className}Adapter.ViewHolder> implements View.OnClickListener {
    private Context mContext;
    private List<${className}> list;
    private OnItemClickListener itemClickListener; //will implement in activity

    public void setItemClickListener (OnItemClickListener itemClickListener) {
        this.itemClickListener = itemClickListener;
    }

    @Override
    public void onClick (View view) {
        if (itemClickListener != null)
            itemClickListener.onItemClick((Integer) view.getTag());
    }

    public ${className}Adapter (Context mContext, List<${className}> list) {
        this.mContext = mContext;
        this.list = list;
    }

    public List<${className}> getList () {
        return list;
    }

    public void setList (List<${className}> list) {
        this.list = list;
    }

    @Override
    public ViewHolder onCreateViewHolder (ViewGroup parent, int viewType) {
        View itemView = LayoutInflater.from(parent.getContext()).
                inflate(R.layout.cardview_${tableName}, parent, false);
        itemView.setOnClickListener(this);
        return new ViewHolder(itemView);
    }

    @Override
    public void onBindViewHolder (ViewHolder holder, int position) {
        holder.itemView.setTag(position);

        ${className} obj = list.get(position);
        holder.name.setText(obj.getName());
        holder.remarks.setText(obj.getRemarks());
        holder.createTime.setText(obj.getCreateTimeStr());

        if(obj.getImgUrl() != null && !"".equals(obj.getImgUrl())){
            Glide.with(mContext)
                .asBitmap()
                .load(Constant.server + File.separator + obj.getImgUrl())
                .into(holder.imgUrl);
        }
    }

    @Override
    public int getItemCount () {
        return list.size();
    }

    class ViewHolder extends RecyclerView.ViewHolder {
        TextView name;
        ImageView imgUrl;
        TextView createTime;
        TextView remarks;

        public ViewHolder (View itemView) {
            super(itemView);

            name = itemView.findViewById(R.id.list_${tableName}_name);
            imgUrl = itemView.findViewById(R.id.list_${tableName}_imgUrl);
            createTime = itemView.findViewById(R.id.list_${tableName}_createTime);
            remarks = itemView.findViewById(R.id.list_${tableName}_remarks);
        }
    }
}
