<#assign v_name_comment><#list columns as c><#if c.field?? && c.field == "name">${c.columnComment}</#if></#list></#assign>
<#assign v_state_comment><#list columns as c><#if c.field?? && c.field == "state">${c.columnComment}</#if></#list></#assign>


<template>
    <div style="height: 100%;padding: 10px;">
        <el-card class="filter-container" shadow="never">
            <header class="el-icon-search" style="margin-bottom: 20px;"><span class="scroll-line" style="margin-left: 5px;">筛选搜索</span></header>
            <!-- 查询开始-->
            <el-row>
                <el-form :model="tableData" ref="searchForm" inline size="mini" class="search" label-width="100px">
                    <el-form-item label=" ${v_name_comment} ">
                        <el-input v-model="tableData.search.name" placeholder="请输入关键字"></el-input>
                    </el-form-item>
                    <el-form-item label="">
                        <el-button size="mini" type="primary" icon="el-icon-search" @click="search()">查 询</el-button>
                        <el-button v-if="tableData.btn.add !='hide'" size="mini" type="success"
                                   @click="onTableEdit('add')" icon="el-icon-circle-plus-outline">添 加
                        </el-button>
                        <el-button v-if="tableData.btn.multipleDelete" size="mini" type="danger"
                                   @click="openDeleteConfirmDialog(multipleSelection)" icon="el-icon-delete">批量删除
                        </el-button>
                    </el-form-item>
                </el-form>
            </el-row>
            <!-- 查询结束-->
        </el-card>

        <el-card class="operate-container" shadow="never" style="margin-top: 15px;">
            <i class="el-icon-tickets"></i>
            <span class="scroll-line">数据列表</span>
        </el-card>

        <vue-table ref="tbl1" :tbl="tableData" @tbl_edit_event="onTableEdit"/>

    <#-- el-form-item的prop一定要写，影响resetForm和rule -->
        <el-dialog title="${vue.title}表单" :visible.sync="dialogFormVisible" width="40%" @close="resetForm('formData')">
            <el-form :model="formData" :rules="rules" ref="formData" label-width="100px">

        <#list columns as c>
        <#-- id，openid，createTime等字段不生成表单 -->
        <#if c.field == "id" || c.field == "openid" || c.field == "createTime" || c.field == "updateTime" >
        <#elseif c.field?? && c.field == "userId">
        <!--<el-form-item label="${c.columnComment}" prop="${c.field}">
            <vue-data-selector ref="ds" :conf="userIdSelectorConf" :value="formData.userId"
                               @vue-data-select="onUserIdDataSelect" :disabled="operation == 'edit'"/>
        </el-form-item>-->
        <#elseif c.dict == true>
        <el-form-item label="${c.columnComment}" prop="${c.field}">
            <vue-dict :defaultValue="formData.${c.field}" type="${c.columnName}" @vue-select="onTypeSelect"/>
        </el-form-item>
        <#elseif c.dataType?? && c.dataType == "Date">
        <el-form-item label="${c.columnComment}" prop="${c.field}">
            <el-date-picker v-model="formData.${c.field}" type="datetime" placeholder="选择日期时间" value-format="yyyy-MM-dd HH:mm:ss"></el-date-picker>
        </el-form-item>
        <#elseif c.dataType?? && c.dataType == "Integer">
        <el-form-item label="${c.columnComment}" prop="${c.field}">
            <el-input-number v-model="formData.${c.field}" :min="0"></el-input-number>
        </el-form-item>
        <#elseif c.field?? && c.field == "remarks">
        <el-form-item label="${c.columnComment}" prop="${c.field}">
            <el-input type="textarea" :rows="5" v-model="formData.${c.field}"></el-input>
        </el-form-item>
        <#elseif c.field?? && c.field == "imgUrl">
        <el-form-item label="${c.columnComment}" prop="${c.field}">
            <vue-uploader ref="img_ref" @vue-upload="onImgUpload" :uploadUrl="formData.imgUrl"></vue-uploader>
        </el-form-item>
        <#elseif c.field == "videoUrl">
        <el-form-item label="${c.columnComment}" prop="${c.field}">
            <vue-uploader ref="video_ref" @vue-upload="onVideoUpload" :uploadUrl="formData.videoUrl"></vue-uploader>
        </el-form-item>
        <#else>
        <el-form-item label="${c.columnComment}" prop="${c.field}">
            <el-input v-model="formData.${c.field}"></el-input>
        </el-form-item>
        </#if>
        </#list>

            </el-form>

            <div slot="footer" class="dialog-footer">
                <el-button @click="dialogFormVisible = false">关闭</el-button>
                <el-button type="primary" @click="submitForm('formData')">提交</el-button>
                <!--
                <el-button type="danger" @click="approveForm('审核不通过')">审核不通过</el-button>
                <el-button type="success" @click="approveForm('审核通过')">审核通过</el-button>
                -->
            </div>

        </el-dialog>

    </div>
</template>

<script>
    ${r"import {approve} from '@/api'"}
    ${r"import {oscarMixin} from '@/config/mixins'"}


    export default {
        mixins: [oscarMixin],
        data() {
            return {
    <#if hasUserIdColumn==true>
      userIdSelectorConf:{
          param:{
              url:'/sys/user/list',
              roleId:3  //student
          },
          columns:['cnName'],//multiple col
      },
    </#if>
                tableData: {
                    url: '${vue.controllerPath}/page',
                    search:{
                        name:null
                    },
                    cols: [
          <#list columns as c>
              <#if c.field?? && c.field == "id">
              <#elseif c.field == "imgUrl" || c.field == "state" >
              <#elseif c.field == "userId">
          {col: 'cnName', label: '${c.columnComment}'},
              <#else>
          {col: '${c.field}', label: '${c.columnComment}' <#if c.dataType?? && c.dataType == "Date">,formatter: this.dateFmt</#if>},
              </#if>
          </#list>
                    ],
                    imgCols:[
          <#list columns as c>
              <#if c.field?? && c.field == "imgUrl">
                {col: '${c.field}', label: '${c.columnComment}', style:{width:'100%',height:'100%'}},
              </#if>
          </#list>
                    ],
        <#if vue.extend==true>
        expandCols: [
            {col: 'name', label: '商品名称'},
            {col: 'imgUrl', label: '图片', type: 'image'},
        ],
        </#if>
        <#if hasStateColumn==true>
        btnCols:[
            {col: 'disabled',displayLabel:'审核', label: '审核操作',type:'success',icon:"el-icon-success"},
        ],
        tagCols:[
            {col: 'state', label: '${v_state_comment}'},
        ],
        </#if>
                    btn: {
                        add: '${vue.addFlag}', delete: '${vue.deleteFlag}', update: '${vue.updateFlag}',detail: '${vue.detailFlag}',multipleDelete: ${vue.multipleDelete?c},width:80
          <#if vue.userDefined==true>
          userDefined: [
              {type: 'success', icon: '${vue.userDefinedIcon}', text: '${vue.userDefinedText}'}
          ]
          </#if>
                    }
                },
                defaultFormData:{},
                formData: {
                    url: '${vue.controllerPath}',
        <#list columns as c>
            ${c.field}:null,
        </#list>
        },
            rules: {
        <#list columns as c>
            <#if c.field?? && c.field == "id">
            <#elseif c.isNullable?? && c.isNullable == "NO">
                ${c.field}: [{required: true, message: '请填写${c.columnComment}'}],
            </#if>
        </#list>
            },
            dialogFormVisible: false,
                    operation: '',
                    multipleSelection:[],
                    userInfo: {},
        }
        },
        created() {
            this.defaultFormData = this.$clone(this.formData)
            this.userInfo = this.$store.state.userInfoState
            this.formData.userId = this.userInfo.id
            // this.tableData.search.id = this.$route.query.id //skip from other page

            if(this.userInfo.roleId != 1){//mime
                this.tableData.search.userId = this.userInfo.id
                //   this.tableData.btn.add = 'hide'
                //   this.tableData.btn.delete = 'hide'
                //   this.tableData.btn.update = 'hide'
                //   this.tableData.btn.multipleDelete = false
            }
        },
        methods: {
    <#if hasUserIdColumn==true>
    onUserIdDataSelect(id){
        this.formData.userId = id
    },
    </#if>
            dateFmt(row, col, cellValue) {
                return cellValue ? this.moment(cellValue).format('YYYY-MM-DD HH:mm:ss') : ''
            },
            async onTableEdit(action, idx, row, col_title) { //表格操作
                this.operation = action
                if (action == 'add') {
                    this.dialogFormVisible = true
                } else if (action == 'detail'){
                    this.$router.push({
                        path:'/${tableName}_detail',
                        query:row
                    })
                } else if (action == 'delete') {
                    this.openDeleteConfirmDialog(row.id)
                } else if (action == 'multipleSelection') {
                    this.multipleSelection = row
                } else if (action == 'edit') {
                    this.dialogFormVisible = true
                    Object.assign(this.formData, row)
                    const that = this
                    //在下次DOM更新循环结束之后执行延迟回调。在修改数据后立即用$nextTick，获取更新后的DOM
                    this.$nextTick(()=>{
                        if(that.$refs.img_ref)
                            that.$refs.img_ref.preview(that.formData.imgUrl)
                        if(that.$refs.video_ref)
                            that.$refs.video_ref.preview(that.formData.videoUrl)
                    })
                } else if(action == 'user_defined'){
                    if (true) {
                        this.$message({
                            message: '成功！',
                            type: 'success'
                        })
                        this.$router.push('/xxx')
                    } else {
                        this.$message({
                            message: '失败！',
                            type: 'error'
                        })
                    }
                }else if(action == 'btn_col'){
                    console.log(col_title)
                }
            },
            openDeleteConfirmDialog(id){
                this.$confirm('确定删除选定的数据吗？', '提示', {
                    confirmButtonText: '确定',
                    cancelButtonText: '取消',
                    type: 'warning'
                }).then(() => {
                    this.removeConfirm(id)
                }).catch(() => {
                    this.$message({
                        type: 'info',
                        message: '取消删除操作！'
                    })
                })
            },
            submitForm(formName) {//提交Form表单
                this.$refs[formName].validate(async (valid) => {
                    if (valid) {
                        let res = await this.$save(this.formData)
                        this.$msg(res, this.refresh)
                        this.dialogFormVisible = false
                        //this.$router.push('/user/center')
                    } else {
                        return this.$formInvalid()
                    }
                })
            },
            async approveForm(state) {//审核Form表单
                this.formData.state = state
                let res = await approve(this.formData)
                this.$msg(res, this.refresh)
                this.dialogFormVisible = false
            },
            async removeConfirm(id){ //删除
                let ids = []
                if(Array.isArray(id)){
                    ids = id.map(x=>x.id)
                }else{
                    ids.push(id)
                }
                const res = await this.$remove({
                    url: this.formData.url, ids
                })
                this.$msg(res, this.refresh)
            },
            resetForm(formName) {
                this.$nextTick(()=>{
                    // this.$refs[formName].resetFields()
                    this.formData = this.$clone(this.defaultFormData)
                    this.$refs.img_ref && this.$refs.img_ref.reset()
                })
            },
            refresh() {
                this.$refs.tbl1.load()
            },
            search(){
                this.refresh()
            },
            onTypeSelect(val){
                this.formData.type = val
            },
<#list columns as c>
    <#if c.field?? && c.field == "imgUrl">
    onImgUpload(url) {
        this.formData.imgUrl = url
    },
    <#elseif c.field == "videoUrl">
    onVideoUpload(url) {
        this.formData.videoUrl = url
    },
    </#if>
</#list>

        }
    }
</script>

<style lang="less">

</style>
