<view class="page" data-weui-theme="{{theme}}">
    <view class="weui-form">
        <!-- ------------------------------- -->
        <view class="weui-form__text-area">
            <h2 class="weui-form__title green">${wechat.title}</h2>
            <!--<view class="weui-form__desc">提交后请假信息将发送到后台</view>-->
        </view>

        <!-- ------------------------------- -->
        <view class="weui-form__control-area">
            <view class="weui-cells__group weui-cells__group_form">

                <!-- <view class="weui-cells__title">表单组标题</view> -->
                <view class="weui-cells weui-cells_form">

            <#list columns as c>
                <#if c.field == "id" || c.field == "createTime" || c.field == "updateTime" || c.field == "remarks">

                <#elseif c.rating == true>
                    <view class="weui-cell weui-cell_active">
                        <view class="weui-cell__hd">
                            <label class="weui-label">${c.columnComment}</label>
                        </view>
                        <view class="weui-cell__bd">
                            <rating bindchange="bindRatingChange"/>
                        </view>
                    </view>
                <#elseif c.dataType == "Integer">
                    <view class="weui-cell weui-cell_active">
                        <view class="weui-cell__hd">
                            <label class="weui-label">${c.columnComment}</label>
                        </view>
                        <view class="weui-cell__bd">
                            <slider data-item="star" bindchange="bindInput" value="12" min="1" max="60" show-value/>
                        </view>
                    </view>
                <#elseif c.dataType == "Date">
                    <view class="weui-cell weui-cell_active weui-cell_select weui-cell_select-after">
                        <view class="weui-cell__hd">
                            <label class="weui-label">${c.columnComment}</label>
                        </view>
                        <view class="weui-cell__bd">
                            <picker mode="date" value="{{${c.field}}}" data-item="${c.field}" bindchange="bindInput">
                                <view class="weui-select">{{${c.field}}}</view>
                            </picker>
                        </view>
                    </view>
                <#elseif c.dict == true>
                    <view class="weui-cell weui-cell_active weui-cell_select weui-cell_select-after">
                        <view class="weui-cell__hd">
                            <label class="weui-label">${c.columnComment}</label>
                        </view>
                        <view class="weui-cell__bd">
                            <picker value="{{${c.field}Index}}" range="{{${c.field}Array}}" range-key="label" data-item="${c.field}Index" bindchange="bindInput">
                                <view class="weui-select">{{${c.field}Array[${c.field}Index].label}}</view>
                            </picker>
                        </view>
                    </view>
                <#elseif c.field == "imgUrl">
                    <view class="weui-cell weui-cell_active">
                        <view class="weui-cell__hd">
                            <label class="weui-label">初版年份</label>
                        </view>
                        <view class="weui-cell__bd">
                            <view class="weui-uploader">
                                <view class="weui-uploader__bd">
                                    <view class="weui-uploader__files" id="uploaderFiles">
                                        <block wx:for="{{files}}" wx:key="*this">
                                            <view class="weui-uploader__file" bindtap="previewImage" id="{{item}}">
                                                <image class="weui-uploader__img" src="{{item}}" mode="aspectFill" />
                                            </view>
                                        </block>
                                    </view>
                                    <view class="weui-uploader__input-box">
                                        <view class="weui-uploader__input" bindtap="chooseImage"></view>
                                    </view>
                                </view>
                            </view>
                        </view>
                    </view>
                <#else>
                    <view class="weui-cell weui-cell_active">
                        <view class="weui-cell__hd">
                            <label class="weui-label">${c.columnComment}</label>
                        </view>
                        <view class="weui-cell__bd">
                            <input class="weui-input" placeholder="填写${c.columnComment}" placeholder-class="weui-input__placeholder" data-item="${c.field}"
                                   value='{{${c.field}}}' bindinput="bindInput"/>
                        </view>
                    </view>
                </#if>
            </#list>
            <#list columns as c>
                <#if c.field == "remarks">
                    <view class="weui-cell ">
                        <view class="weui-cell__bd">
                                <textarea class="weui-textarea" placeholder="请输入${c.columnComment}" rows="2" data-item="${c.field}"
                                          value='{{${c.field}}}' bindinput="bindInput"></textarea>
                            <view class="weui-textarea-counter">
                                <text>{{${c.field}.length}}</text>/200
                            </view>
                        </view>
                    </view>
                </#if>
            </#list>

                </view>
            </view>
        </view>

        <view class="weui-form__tips-area">
            <view class="weui-form__tips">

            </view>
        </view>

        <!-- ------------------------------- -->
        <view class="weui-form__opr-area">
            <a class="weui-btn weui-btn_primary" bindtap="bindSubmit">提交</a>
        </view>

        <view class="weui-form__extra-area">
            <view class="weui-footer">
                <view class="weui-footer__links">
                    <a href="javascript:" class="weui-footer__link"> </a>
                </view>
                <view class="weui-footer__text">Copyright © 2020-2021</view>
            </view>
        </view>

    </view>

    <!-- dialog -->
    <view class="fadeIn" wx:if="{{resultDialog}}">
        <view class="weui-mask"></view>
        <view class="weui-dialog weui-skin_android">
            <view class="weui-dialog__bd">
                描述尽量控制在三行内
            </view>
            <view class="weui-dialog__ft">
                <a class="weui-dialog__btn weui-dialog__btn_default" bindtap="close">辅助操作</a>
                <a class="weui-dialog__btn weui-dialog__btn_primary" bindtap="close">主操作</a>
            </view>
        </view>
    </view>

</view>

<!-- 浮动btn -->
<!--<image class="primary-bg-color right-bottom-btn" src="/assets/images/com/add.png"></image>-->
