var app = getApp()

Page({
  mixins: [require('../../mixin/themeChanged')],
  data: {
    inputShowed: false,
    inputVal: "",
    list:[],
    allList:[],
    recommendList:[],
    bannerList:[]
  },

  bindBtn: function () {
    wx.navigateTo({
      url: '/pages/${wechat.fileName}/form',
    })
  },

  onLoad: function(options) {
    app.that = this
    app.util.log('${wechat.title}')
    this.setData({
      server: app.conf.server + "/"
    })
    this.init()
  },

  init: function(){
    app.httpclient.query('${wechat.controllerPath}/list', {
      //userId: app.globalData.userInfo.id
    }, res => {
      let list = res.map(o => {
        o.query = JSON.stringify(o)
        return o
      })
      let recommendList = []
      <#if wechat.recommend == true>
      let shuffleList = app.that.shuffle(list)
      recommendList = shuffleList.slice(0,Math.min(3,shuffleList.length))
      </#if>
      app.that.setData({
        list,
        allList:list,
        recommendList
      })
    })

    <#if wechat.recommend == true>
    app.httpclient.request('/sys/banner/list', bannerList => {
      app.that.setData({
        bannerList
      })
    })
    </#if>
  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function() {
    this.init()
  },

  <#if wechat.recommend == true>
  changeRecommend(){
    this.shuffle(this.data.recommendList)
  },
  shuffle(arr){
    //clone array
    let newArr = arr.slice(0)
    let rand = function(min,max){
      return Math.floor(Math.random() * (max - min + 1) + min)
    }
    for (let i = 0; i < newArr.length; i++) {
      let j = rand(0, i)
      let temp = newArr[i]
      newArr[i] = newArr[j]
      newArr[j] = temp
    }
    return newArr
  },
  </#if>

  <#if wechat.searchBar == true>
  showInput: function () {
    this.setData({
      inputShowed: true
    });
  },
  hideInput: function () {
    let searchText = this.data.inputVal
    let list = this.data.allList.filter(x=> x.name.indexOf(searchText) != -1)
    this.setData({
      list,
      inputVal: "",
      inputShowed: false
    });
  },
  clearInput: function () {
    this.setData({
      inputVal: ""
    });
  },
  inputTyping: function (e) {
    this.setData({
      inputVal: e.detail.value
    })
  },
  </#if>
})