<#--  搜索框  -->
<#if wechat.searchBar == true>
<view class="page" data-weui-theme="{{theme}}">
  <view class="page__bd">
  <view class="weui-search-bar {{inputShowed ? 'weui-search-bar_focusing' : ''}}" id="searchBar">
    <form class="weui-search-bar__form">
    <view class="weui-search-bar__box">
      <i class="weui-icon-search"></i>
      <input type="text" class="weui-search-bar__input" placeholder="搜索" value="{{inputVal}}" focus="{{inputShowed}}" bindinput="inputTyping" />
      <span class="weui-icon-clear" wx:if="{{inputVal.length > 0}}" bindtap="clearInput"></span>
    </view>
    <label class="weui-search-bar__label" bindtap="showInput">
      <i class="weui-icon-search"></i>
      <span class="weui-search-bar__text">搜索</span>
    </label>
    </form>
    <view class="weui-search-bar__cancel-btn" bindtap="hideInput">搜索</view>
  </view>
  </view>
</view>
</#if>

<#--  banner轮播  -->
<#if wechat.banner == true>
<view class='swiper base-padding base-margin-bottom'>
  <swiper indicator-dots="true" autoplay="true" interval="5000" duration="1000">
  <block wx:for="{{bannerList}}" wx:key="id">
  <swiper-item>
  <image wx:if="{{server}}" src="{{server+item.imgUrl}}" mode='widthFix' class="slide-image"/>
  </swiper-item>
  </block>
  </swiper>
</view>
</#if>

<#--  推荐  -->
<#if wechat.recommend == true>
<view class='panel base-padding recommend base-margin-bottom'>
  <view class='panel-heading'>
  <view class='panel-title font-lv1 strong'>推荐
  <view class='pull-right font-lv3 color-link' bindtap='changeRecommend'>换一批</view>
  </view>
  </view>
  <view class='panel-body'>

  <navigator url="/pages/${wechat.fileName}/detail?query={{item.query}}" wx:for="{{recommendList}}" wx:key="id">
    <image mode='widthFix'  class='box-shadow cover' src='{{server+item.imgUrl}}'/>
    <view class='font-lv3 ellipsis-2row mgt-15rpx'>{{item.name}}</view>
  </navigator>

  </view>
</view>
</#if>

<#--  列表展示  -->
<#if wechat.listType == 1>
<view class='panel base-padding base-margin-bottom info-list'>
  <view class='panel-heading'>
  <view class='panel-title font-lv1 strong'>
  ${wechat.title}列表
  <#if wechat.genForm == true>
  <navigator url="/pages/${wechat.fileName}/form" class="pull-right">
  <view class='color-link font-lv3'>新建</view>
  </navigator>
  </#if>
  </view>
  </view>

  <view class='panel-body'>

  <view class='row' wx:for="{{list}}" wx:key="id">
  <view class='row-left'>
  <navigator url="/pages/${wechat.fileName}/detail?query={{item.query}}">
    <image mode='widthFix' class='box-shadow cover' src='{{server+item.imgUrl}}'/>
  </navigator>
  </view>
  <view class='row-right'>
  <navigator url='/pages/${wechat.fileName}/detail?query={{item.query}}' class='ellipsis-2row font-lv2' style="line-height:1.3;">
    {{item.name}}
  </navigator>
  <view class='text-muted info'>
    <view>
    <image src='/assets/images/sys/ic_clock.png'></image>
    {{item.createTimeStr}}
    </view>
    <view>
    <image src='/assets/images/sys/ic_document.png'></image>
    {{item.type}}
    </view>
    <view>
    <image src='/assets/images/sys/ic_eye.png'></image>
    1312 阅读
    </view>
  </view>
  <view class='text-muted ellipsis-3row desc'>{{item.remarks}}</view>
  </view>
  </view>

  </view>
</view>
</#if>

<#--  单行列表，右侧有删除图标  -->
<#if wechat.listType == 2>
<view class='base-padding font-lv3'>
  <view class='row'>
    <view class='col-11 panel-title font-lv1 strong'>
      <navigator class='color'>${wechat.title}列表</navigator>
    </view>
    <navigator url="/pages/${wechat.fileName}/form">
      <text class='font-lv3 color-link'>新建</text>
    </navigator>
  </view>

  <view class='row' wx:for="{{list}}" wx:key="id">
    <view class='col-10'>
        <navigator url="/pages/${wechat.fileName}/detail?query={{item.query}}">{{item.name}}</navigator>
    </view>
    <view class='col-2'>
      <text class="op-btn" data-item="{{item}}" bindtap="bindClick">答题</text>
    </view>
  </view>
</view>
</#if>

<#--  cardview形式  -->
<#if wechat.listType == 3>
<view class="black">
  <view class="container" wx:for="{{list}}" wx:key="id">
  <image src="{{server+item.imgUrl}}" class="scroll-image" />
  <view class="content">
  <view class="title">{{item.name}}</view>
  <view class="scroll-view-item-AT">
  <view class="area">疾病：{{item.disease}}</view>
  </view>
  <view class="scroll-view-item-AT">
  <view class="area">推荐食物：{{item.food}}</view>
  </view>
  <view class="scroll-view-item-cf">
  <navigator url="/pages/${wechat.fileName}/detail?query={{item.query}}" class='color'>
    <view class="reserve" bindtap="article">全文</view>
  </navigator>
  </view>
  </view>
  </view>
</view>
</#if>

<#if wechat.listType == 4>
<view class="page" data-weui-theme="{{theme}}">
  <view class="page__bd">
    <view class="weui-panel">
      <view class="weui-panel__hd">${wechat.title}列表</view>
      <view class="weui-panel__bd">
        <view class="weui-media-box weui-media-box_text" wx:for="{{list}}" wx:key="id">
          <h4 class="weui-media-box__title bold green">{{item.name}}</h4>
          <image wx:if="{{index == 0}}" src="/assets/images/gif/new.gif" style="width:35px;height:13px;"></image>
          <view class="weui-media-box__desc">{{item.remarks}}</view>
          <view class="weui-media-box__info">
            <view class="weui-media-box__info__meta red">额外信息</view>
            <view class="weui-media-box__info__meta weui-media-box__info__meta_extra">{{item.createTimeStr}}</view>
          </view>
        </view>
      </view>
    </view>
  </view>
</view>
</#if>

<!-- <view class='pagination pd-30rpx'>
  <view class='text-center font-lv3 color-grey'>上拉加载更多</view>
</view> -->