package com.oscar;

import com.google.common.base.Stopwatch;
import org.junit.After;
import org.junit.AfterClass;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.runner.RunWith;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.junit4.SpringRunner;

import java.util.concurrent.TimeUnit;


@RunWith(SpringRunner.class)
@SpringBootTest
public class SpringbootUnitTests {
    private static Stopwatch stopwatch;

    @BeforeClass
    public static void init () {
        System.out.println("execute only once");
        stopwatch = Stopwatch.createUnstarted();
    }

    @Before
    public void setUp () { //每个test方法前都执行一次
        System.out.println("will execute before every @Test method");
        stopwatch.start();
    }

    @After
    public void tearDown () {
        stopwatch.stop();
        System.out.println(stopwatch.elapsed(TimeUnit.MILLISECONDS) + " " + TimeUnit.MILLISECONDS.name().toLowerCase());
        stopwatch.reset();
    }

    @AfterClass
    public static void destroy () {

    }
}
