package ${android.packageName};

import android.app.AlertDialog;
import android.content.DialogInterface;
import android.content.Intent;
import android.os.Bundle;
import android.support.v7.widget.LinearLayoutManager;
import android.support.v7.widget.RecyclerView;
import butterknife.BindView;
import butterknife.ButterKnife;
import com.google.gson.Gson;
import com.google.gson.reflect.TypeToken;
import com.oscar.R;
import com.oscar.base.AbstractActivity;
import com.oscar.base.ActionBarControl;
import com.oscar.base.listener.OnItemClickListener;
import com.oscar.base.network.ListCallback;
import com.oscar.base.network.ObservableFetch;
import com.oscar.modules.sys.comment.SysCommentActivity;

import java.util.ArrayList;
import java.util.List;

public class ${className}Activity extends AbstractActivity {
    private ${className}Adapter adapter;
    List<${className}> mList = new ArrayList<>();
    ${className} currentClickItem;

    @BindView(R.id.rv_${tableName})
    public RecyclerView recyclerView;

    @Override
    protected String setTitle () {
        return "${android.title}";
    }

    @Override
    protected int setActivityLayout () {
        return R.layout.activity_${tableName};
    }

    @Override
    protected void onActivityCreate (Bundle savedInstanceState) {
        recyclerView.setHasFixedSize(true);

        //确定RecyclerView内各个item的位置
        LinearLayoutManager layoutManager = new LinearLayoutManager(mContext);
        layoutManager.setOrientation(LinearLayoutManager.VERTICAL);//同ListView
        recyclerView.setLayoutManager(layoutManager);

        adapter = new ${className}Adapter(mContext, mList);
        recyclerView.setAdapter(adapter);

        adapter.setItemClickListener(new OnItemClickListener() {
            @Override
            public void onItemClick (int position) {
                currentClickItem = mList.get(position);
                //navigateTo(${className}FormActivity.class, currentClickItem);
                new AlertDialog.Builder(mContext).setTitle("确认如下操作吗？")
                        .setPositiveButton("确定", new DialogInterface.OnClickListener() {
                            @Override
                            public void onClick (DialogInterface dialogInterface, int i) {

                            }
                        })
                        .setNeutralButton("取消", new DialogInterface.OnClickListener() {
                            @Override
                            public void onClick (DialogInterface dialogInterface, int i) {
                            }
                        }).show();
            }
        });
    }

    @Override
    protected void onResume () {
        loadData();
        super.onResume();
    }

    private void loadData(){
        new ObservableFetch().get("${android.controllerPath}/list", new ListCallback<${className}>() {
            @Override
            public void success (List<${className}> list) {
                Gson g = new Gson();
                mList = g.fromJson(g.toJson(list), new TypeToken<ArrayList<${className}>>() {}.getType());
                adapter.setList(mList);
                adapter.notifyDataSetChanged();
            }
        });
    }

<#if android.hasForm == true>
    @Override
    protected void onActionBarMenuClick (int id) {
        switch (id) {
            case R.id.id_action_add:
                final Intent intent = new Intent(mContext, ${className}FormActivity.class);
                intent.putExtra("operation", "create");
                startActivity(intent);
                break;
            case R.id.id_action_user_define:
                break;
            default:
                break;
        }
    }
</#if>

<#if android.hasSearch == true>
    @Override
    protected void filterList (String query) {
        if(!"".equals(query)){
            List<${className}> filter = new ArrayList<>();
            for (${className} item : mList) {
                if (item.getName().contains(query)) {
                    filter.add(item);
                }
            }
            adapter.setList(filter);
        }else{
            adapter.setList(mList);//search all
        }

        adapter.notifyDataSetChanged();
    }
</#if>

    @Override
    protected void onActivityResult (int requestCode, int resultCode, Intent data) {
        <#if android.hasCamera == true>
        if (resultCode == RESULT_OK) {
            super.onCameraActivityResult(requestCode, resultCode, data);
        }
        </#if>

        super.onActivityResult(requestCode, resultCode, data);
    }
}