<?xml version="1.0" encoding="utf-8"?>
<ScrollView xmlns:android="http://schemas.android.com/apk/res/android"
    xmlns:app="http://schemas.android.com/apk/res-auto"
    xmlns:tools="http://schemas.android.com/tools"
    android:layout_width="match_parent"
    android:layout_height="match_parent">

    <LinearLayout
        android:layout_width="match_parent"
        android:layout_height="match_parent"
        android:orientation="vertical">

        <TextView
            android:id="@+id/form_top_${tableName}"
            android:layout_width="match_parent"
            android:layout_height="wrap_content"
            android:paddingBottom="@dimen/qmui_group_list_section_header_footer_padding_vertical"
            android:paddingLeft="?attr/qmui_content_padding_horizontal"
            android:paddingRight="?attr/qmui_content_padding_horizontal"
            android:paddingTop="@dimen/qmui_group_list_section_header_footer_padding_vertical"
            android:text="${android.title}"
            android:textColor="?attr/qmui_config_color_gray_3"
            android:textSize="@dimen/qmui_group_list_section_header_footer_text_size"
            android:textStyle="bold"
            android:textAlignment="center" />
        <!--边框分割细线-->
        <LinearLayout
            android:layout_width="match_parent"
            android:layout_height="1dp"
            android:background="@drawable/qmui_s_list_item_bg_with_border_bottom" />

        <GridLayout
            android:layout_width="match_parent"
            android:layout_height="wrap_content"
            android:background="@color/qmui_config_color_white"
            android:columnCount="2"
            android:focusable="true"
            android:focusableInTouchMode="true">

            <#list columns as c>
            <#if c.field?? && c.field == "remarks">
            <TextView
                android:layout_width="wrap_content"
                android:layout_height="@dimen/qmui_list_item_height"
                android:layout_gravity="fill_horizontal"
                android:background="@drawable/qmui_s_list_item_bg_with_border_bottom"
                android:gravity="center_vertical"
                android:paddingLeft="8dp"
                android:paddingRight="8dp"
                android:text="${c.columnComment}"
                android:textColor="?attr/qmui_config_color_gray_1"
                android:textSize="?attr/qmui_common_list_item_title_h_text_size"
                tools:ignore="HardcodedText" />
            <EditText
                android:id="@+id/form_${tableName}_${c.field}"
                android:layout_width="wrap_content"
                android:layout_height="wrap_content"
                android:layout_gravity="fill"
                android:background="@drawable/textarea_shape"
                android:hint=""
                android:scrollHorizontally="false"
                android:textColor="?attr/qmui_config_color_gray_5"
                android:textSize="?attr/qmui_common_list_item_detail_h_text_size"
                android:enabled="true"
                android:gravity="top"
                android:minLines="6"
                android:maxLines="9"
                android:scrollbars="vertical"
                android:inputType="textMultiLine"
                android:text=""
                android:ems="15"
                android:layout_marginRight="8dp" />
            <#elseif c.field?? && c.field == "imgUrl">
            <TextView
                android:layout_width="wrap_content"
                android:layout_height="@dimen/qmui_list_item_height"
                android:layout_gravity="fill_horizontal"
                android:background="@drawable/qmui_s_list_item_bg_with_border_bottom"
                android:gravity="center_vertical"
                android:paddingLeft="8dp"
                android:paddingRight="8dp"
                android:text="${c.columnComment}"
                android:textColor="?attr/qmui_config_color_gray_1"
                android:textSize="?attr/qmui_common_list_item_title_h_text_size"
                tools:ignore="HardcodedText" />
            <com.qmuiteam.qmui.widget.QMUIRadiusImageView
                android:id="@+id/form_${tableName}_${c.field}"
                android:layout_width="48dp"
                android:layout_height="wrap_content"
                android:clickable="true"
                android:src="@drawable/ic_add"
                app:qmui_border_color="?attr/qmui_config_color_gray_6"
                app:qmui_border_width="1px"
                app:qmui_corner_radius="15dp"
                app:qmui_selected_border_color="?attr/qmui_config_color_gray_4"
                app:qmui_selected_border_width="1px"
                app:qmui_selected_mask_color="?attr/qmui_config_color_gray_8"/>
            <#elseif c.field?? && c.field != "id" && c.field != "parentId" && c.field != "state" && c.field != "createTime" && c.field != "updateTime">
            <TextView
                android:layout_width="wrap_content"
                android:layout_height="@dimen/qmui_list_item_height"
                android:layout_gravity="fill_horizontal"
                android:background="@drawable/qmui_s_list_item_bg_with_border_bottom"
                android:gravity="center_vertical"
                android:paddingLeft="8dp"
                android:paddingRight="8dp"
                android:text="${c.columnComment}"
                android:textColor="?attr/qmui_config_color_gray_1"
                android:textSize="?attr/qmui_common_list_item_title_h_text_size"
                tools:ignore="HardcodedText" />
            <EditText
                android:id="@+id/form_${tableName}_${c.field}"
                android:layout_width="wrap_content"
                android:layout_height="wrap_content"
                android:layout_gravity="fill"
                android:gravity="center_vertical"
                android:background="@drawable/qmui_divider_bottom_bitmap"
                android:hint="请输入${c.columnComment}..."
                android:maxLength="20"
                android:textColor="?attr/qmui_config_color_gray_5"
                android:textSize="?attr/qmui_common_list_item_detail_h_text_size" />
            </#if>
            </#list>

        </GridLayout>

        <!--btn-->
        <LinearLayout
            android:layout_width="match_parent"
            android:layout_height="wrap_content"
            android:background="@color/qmui_config_color_white"
            android:orientation="horizontal"
            android:padding="8dp">

            <Space
                android:layout_width="0dp"
                android:layout_height="match_parent"
                android:layout_weight="1" />

            <com.qmuiteam.qmui.widget.roundwidget.QMUIRoundButton
                android:id="@+id/btn_submit_${tableName}"
                android:layout_width="wrap_content"
                android:layout_height="wrap_content"
                android:layout_weight="2"
                android:clickable="true"
                android:gravity="center"
                android:padding="10dp"
                android:text="确 认"
                android:textSize="?attr/qmui_common_list_item_title_h_text_size"
                app:qmui_isRadiusAdjustBounds="true"
                app:qmui_radius="4dp" />

            <Space
                android:layout_width="0dp"
                android:layout_height="match_parent"
                android:layout_weight="1" />

        </LinearLayout>
    </LinearLayout>

</ScrollView>
