package ${android.packageName};

import android.graphics.Bitmap;
import android.os.Bundle;
import android.view.View;
import android.widget.Button;
import android.widget.GridLayout;
import android.widget.TextView;
import butterknife.BindView;
import butterknife.ButterKnife;
import com.oscar.R;
import com.oscar.base.AbstractActivity;
import com.oscar.base.AbstractEntity;
import com.oscar.base.Constant;
import com.oscar.base.network.EntityCallback;
import com.oscar.base.network.ObservableFetch;
import com.oscar.util.ToastUtils;
import com.qmuiteam.qmui.widget.QMUIRadiusImageView;

import java.util.Date;

public class ${className}FormActivity extends AbstractActivity {
    ${className} ${entityVar} = new ${className}();
    ${className} currentClickItem;

    @BindView(R.id.btn_submit_${tableName})
    public Button submitBtn;

    <#list columns as c>
    <#if c.field?? && c.field == "imgUrl">
    @BindView(R.id.form_${tableName}_${c.field})
    public QMUIRadiusImageView ${c.field};
    <#elseif c.field?? && c.field != "id" && c.field != "parentId" && c.field != "state" && c.field != "createTime" && c.field != "updateTime">
    @BindView(R.id.form_${tableName}_${c.field})
    public TextView ${c.field};
    </#if>
    </#list>

    @Override
    protected int setActivityLayout () {
        return R.layout.activity_form_${tableName};
    }

    @Override
    protected String setTitle () {
        return "${android.title}";
    }

    @Override
    protected void onActivityCreate (Bundle savedInstanceState) {
        currentClickItem = (${className})getSerializableExtra(Constant.intent_param_key);
        submitBtn.setOnClickListener(this);
        <#list columns as c>
        <#if c.field?? && c.field == "imgUrl">
        ${c.field}.setOnClickListener(this);
        </#if>
        </#list>
    }

    @Override
    public void onClick (View view) {
        switch (view.getId()) {
            <#list columns as c>
            <#if c.field?? && c.field == "imgUrl">
            case R.id.form_${tableName}_${c.field}:
                popupWindow();
                break;
            </#if>
            </#list>
            case R.id.btn_submit_${tableName}:
                <#list columns as c>
                <#if c.field?? && c.field != "id" && c.field != "parentId" && c.field != "state" && c.field != "imgUrl" && c.field != "createTime" && c.field != "updateTime">
                    <#if c.dataType == "Integer">
                ${entityVar}.${c.setter}(Integer.parseInt(${c.field}.getText().toString()));
                    <#else>
                ${entityVar}.${c.setter}(${c.field}.getText().toString());
                    </#if>
                </#if>
                </#list>

                new ObservableFetch().post("${android.controllerPath}", ${entityVar}, new EntityCallback() {
                    @Override
                    public void success (Object result) {
                        ToastUtils.show(mContext,"提交成功");
                        finish();
                    }
                });
                break;
            default:
                break;
        }
    }

<#list columns as c>
    <#if c.field?? && c.field == "imgUrl">
    @Override
    protected void setImageThumbnail (Bitmap resource) {
        ${c.field}.setImageBitmap(resource);
        final GridLayout.LayoutParams layoutParams = new GridLayout.LayoutParams();
        layoutParams.width = 240;
        ${c.field}.setLayoutParams(layoutParams);
    }

    @Override
    protected void setImageId (String imageId) {
        ${entityVar}.setImgUrl(imageId);
    }
    </#if>
</#list>
}