const dao = require('../../db')
const Base_Column_List =
<#if hasUserIdColumn==true>
    'b.cn_name,'+
</#if>
<#assign columnField>
    <#list columns as c>
    'a.${c.columnName},'+
    </#list>
</#assign>
${columnField?substring(0, columnField?last_index_of(","))} '

const Base_Joins = ' <#if hasUserIdColumn==true>LEFT JOIN sys_user b on a.user_id = b.id</#if> '
const where = ' where 1=1 '
const findList_Sql = function (params) {
    let sql = 'SELECT ' + Base_Column_List + ' FROM ${tableName} a ' + Base_Joins + where
    let sqlParams = []
    if (params.id) {
        sql += ' AND a.id = ? '
        sqlParams.push(params.id)
    }
    if (params.type) {
        sql += ' AND a.type = ? '
        sqlParams.push(params.type)
    }
    <#if hasUserIdColumn==true>
    if (params.userId) {
        sql += ' AND a.user_id = ? '
        sqlParams.push(params.userId)
    }
    </#if>
    if (params.name) {
        sql += ' AND a.name LIKE "%' + params.name + '%"'
    }

    //order by

    if (params.pagination) {
        sql += ' LIMIT ' + (params.pageNum - 1)*params.pageSize + ',' + params.pageSize
    }

    return {
        sql, sqlParams
    }
}

const insert_Sql = function (params) {
    let sql = 'INSERT INTO ${tableName}(' +
		<#assign insertField>
        <#list columns as c>
            <#if c.columnName != "id">
            '${c.columnName},'+
            </#if>
        </#list>
        </#assign>
        ${insertField?substring(0, insertField?last_index_of(","))}'+
        ') VALUES (<#assign insertJavaField><#list columns as c><#if c.columnName != "id">?,</#if></#list></#assign>${insertJavaField?substring(0, insertJavaField?last_index_of(","))})'
    let sqlParams = []
    <#list columns as c>
    <#if c.columnName != "id">
    sqlParams.push(params.${c.field})
    </#if>
    </#list>

    return {
        sql, sqlParams
    }
}

const update_Sql = function (params) {
    let sql = 'UPDATE ${tableName} a SET ' +
    <#assign updateField>
    <#list columns as c>
        <#if c.columnName != "id">
        '${c.columnName} = ?,'+
        </#if>
    </#list>
    </#assign>
    ${updateField?substring(0, updateField?last_index_of(","))}'
        ' WHERE a.${primaryKey.columnName} = ?'
    let sqlParams = []
    <#list columns as c>
    <#if c.columnName != "id">
    sqlParams.push(params.${c.field})
    </#if>
    </#list>
    sqlParams.push(params.id)

    return {
        sql, sqlParams
    }
}

const delete_Sql = function (params) {
    return {
        sql: 'delete from ${tableName} WHERE id = ?',
        sqlParams: [params.id]
    }
}

module.exports = { //类似于Dao
    async pageList(params) {
        // total,pageNum,pageSize,size:res.length,
        let all = await dao.execSql(findList_Sql(params))
        params.pagination = true
        let page = await dao.execSql(findList_Sql(params))
        return {
            code: 0,
            type: 'success',
            message: '操作成功',
            total: all.length,
            size: page.length,
            pageNum: parseInt(params.pageNum),
            pageSize: parseInt(params.pageSize),
            list:page
        }
    },
    async findList(params) {
        return await dao.execSql(findList_Sql(params))
    },
    async save(params) {
        if(params.id){
            params.updateTime = new Date()
            await dao.execSql(update_Sql(params))
        }else{
            params.createTime = new Date()
            await dao.execSql(insert_Sql(params))
        }
    },
    async delete(params) {
        return await dao.execSql(delete_Sql(params))
    },
    async exec(sqlAndParams){
        return await dao.execSql(sqlAndParams)
    }
}