<?xml version="1.0" encoding="UTF-8" ?>
<!DOCTYPE mapper PUBLIC "-//mybatis.org//DTD Mapper 3.0//EN" "http://mybatis.org/dtd/mybatis-3-mapper.dtd" >
<mapper namespace="${packageName}.${className}Mapper" >
    <sql id="Base_Column_List" >
        <#if hasUserIdColumn==true>
        b.cn_name,
        </#if>
        <#assign columnField>
        <#list columns as c>
        a.${c.columnName},
        </#list>
        </#assign>
        ${columnField?substring(0, columnField?last_index_of(","))}
    </sql>

    <sql id="Base_Joins">
    <#if hasUserIdColumn==true>
      LEFT JOIN sys_user b on a.user_id = b.id
    </#if>
    </sql>

    <select id="findList" resultType="${className}">
        SELECT
        <include refid="Base_Column_List"/>
        FROM ${tableName} a
        <include refid="Base_Joins"/>
        <where>
            <if test="${primaryKey.field} != null and ${primaryKey.field} != '' ">
                AND a.${primaryKey.columnName} = ${"#"}{${primaryKey.field}}
            </if>
            <#if hasUserIdColumn==true>
            <if test="userId != null and userId != '' ">
                AND a.user_id = ${"#"}{userId}
            </if>
            </#if>
            <if test="name != null and name != '' ">
                AND a.name like '%${"$"}{name}%'
            </if>
            <if test="remarks != null and remarks != '' ">
                AND a.remarks like '%${"$"}{remarks}%'
            </if>
        </where>
    </select>

    <insert id="insert">
        <selectKey resultType="java.lang.Integer" keyProperty="id">
            SELECT LAST_INSERT_ID()
        </selectKey>

        INSERT INTO ${tableName}(
		<#assign insertField>
        <#list columns as c>
            <#if c.extra?? && c.extra == "auto_increment">
            <#else>
            ${c.columnName},
            </#if>
        </#list>
        </#assign>
    ${insertField?substring(0, insertField?last_index_of(","))}
        ) VALUES (
		<#assign insertJavaField>
        <#list columns as c>
            <#if c.extra?? && c.extra == "auto_increment">
            <#else>
            ${"#"}{${c.field}},
            </#if>
        </#list>
        </#assign>
    ${insertJavaField?substring(0, insertJavaField?last_index_of(","))}
        )
    </insert>

    <insert id="batchInsert">
        INSERT INTO ${tableName}() VALUES
        <foreach collection="list" item="item" index="index" separator=",">
            ()
        </foreach>
    </insert>

    <update id="update">
        UPDATE ${tableName} a SET
        <#assign updateField>
        <#list columns as c>
            <#if c.extra?? && c.extra == "auto_increment">
            <#else>
            ${c.columnName} = ${"#"}{${c.field}},
            </#if>
        </#list>
        </#assign>
    ${updateField?substring(0, updateField?last_index_of(","))}
        WHERE a.${primaryKey.columnName} = ${"#"}{${primaryKey.field}}
    </update>

    <delete id="delete">
        delete from ${tableName}
        WHERE ${primaryKey.columnName} = ${"#"}{${primaryKey.field}}
    </delete>

    <delete id="batchDelete">
        delete from ${tableName}
        WHERE ${primaryKey.columnName} IN
        <foreach collection="list"  item="item" open="(" separator="," close=")">
            ${"#"}{item}
        </foreach>
    </delete>
    
    <select id="demo">
        select DATE_FORMAT(a.create_time,'%Y-%m') months,
               DATE_FORMAT(a.create_time,'%Y-%m-%d') days from sys_user a
    </select>

</mapper>