<!-- 标准Page -->
<template>
  <div>
  <#if vux.topBarButton == 'add'>
    <x-header class="oscar-bg">${vux.title}
      <router-link slot="right" tag='a' to='/m/${tableName}_detail' class="oscar-text">新建</router-link>
    </x-header>
  <#elseif vux.topBarButton == 'more'>
    <x-header class="oscar-bg" :right-options="{showMore: true}" @on-click-more="showMoreMenus = true">${vux.title}</x-header>
    <div v-transfer-dom>
      <actionsheet :menus="menus" v-model="showMoreMenus" show-cancel @on-click-menu="onMenuItemClick"></actionsheet>
    </div>
  <#else>
    <x-header class="oscar-bg">${vux.title}</x-header>
  </#if>

    <panel header="${vux.title}列表" :list="list" :type="type"></panel>

<#if vux.hasTabBar == true>
  <tabbar style="position: fixed">
    <tabbar-item :link="item.link" :selected="item.link == '/m/me'" v-for="(item, index) in tabList" :key="index">
        <img slot="icon" :src="assetsPath + item.imgUrl">
        <span slot="label">{{item.name}}</span>
    </tabbar-item>
  </tabbar>
</#if>

  </div>
</template>

<script>
    import {Panel, XHeader, XButton,TransferDom, Actionsheet, Tabbar, TabbarItem} from 'vux'
  import {getList} from '@/api'
  import {baseUrl, baseImgPath} from '@/config/env'

  export default {
    components: {
        Panel, XHeader, XButton, Actionsheet, Tabbar, TabbarItem
    },
    <#if vux.topBarButton == 'more'>
    directives: {
        TransferDom
    },
    </#if>
    data() {
      return {
        assetsPath:'/static/style/mobile/icon/',
        tabList:[], //tabbar
        showMoreMenus:false,
        menus: {
          menu1: '菜单-1',
          menu2: '菜单-2'
        },
        type: '${vux.listType}',
        list: [],
        baseUrl,
      }
    },
    created() {
      this.dataInit()
<#if vux.hasTabBar == true>
      this.tabListInit()
</#if>
    },
    methods: {
      async dataInit() {
        let that = this
        const res = await getList({url: '${vue.controllerPath}/m/list'})
        if (res.code == 0) {
          this.list = res.data.map(o => {
            o.url = {
              path: '/m/${tableName}_detail',
              query: o.entity
            }
            if(o.src) o.src = that.baseUrl + '/' + o.src

            return o
          })
        }
      },
<#if vux.hasTabBar == true>
      async tabListInit(){
        const res = await getList({url: '/sys/desc/list', type:'tabbar'})
        if (res.code == 0) this.tabList = res.data
      },
</#if>
      onMenuItemClick(key, value){
      },
    },
  }
</script>

<style lang="less">

</style>