<template>
    <div style="padding-top:22%;">

        <divider><img src="/static/style/mobile/logo/0.png"/></divider>

        <group style="margin:20px;" class="oscar-text">
            <x-input class="oscar-bg" title="用户名" v-model="formData.username"></x-input>
            <x-input class="oscar-bg" title="密码" v-model="formData.password"></x-input>
        </group>

        <toast v-model="tip.show" type="warn" is-show-mask :text="tip.text"></toast>

        <div style="padding:20px;">
            <div style="font-size: 14px;color: #fff;margin-bottom: 11px;">
                <span style="color: #bcd9f3;margin-right: 10px;">首次登陆请先</span>
                <router-link style="color:#fff;" to="/m/register">注册</router-link>
            </div>
            <x-button class="oscar-btn" @click.native="onLogin" type="primary">登录</x-button>
        </div>

    </div>
</template>

<script>
    import {Search, Group, Cell, XButton, XInput, XTable, Divider, Radio, Toast} from 'vux'
    import {save, getList} from '@/api'

    export default {
        components: {
            Search,
            Group,
            Cell,
            XButton,
            XInput, XTable, Divider, Radio, Toast
        },
        data() {
            return {
                tip: {
                    show: false,
                    text: ''
                },
                formData: {
                    url: '/m/login',
                    username: '',
                    password: ''
                },
            }
        },
        created() {
            this.webAuth()
        },
        methods: {
            async onLogin() {
                if (this.formData.username == '') {
                    this.tip = {show: true, text: '用户名不能为空！'}
                    return
                }
                if (this.formData.password == '') {
                    this.tip = {show: true, text: '密码不能为空！'}
                    return
                }

                const res = await save(this.formData)
                if (res.code == 0) {
                    sessionStorage.setItem("login_user", JSON.stringify(res.data))
                    this.$router.push("/m/desktop")
                } else {
                    this.tip = {show: true, text: '用户名或密码不正确！'}
                }
            },
            changePwd() {
                this.$router.push('/m_password')
            },
            webAuth() {

            }
        },
        beforeRouteEnter(to, from, next) {
            // document.querySelector('body').setAttribute('style', 'background:#fff111')
            window.document.body.style.backgroundColor = '${pageStyle.background}'
            next()
        },
        beforeRouteLeave(to, from, next) {
            let body = window.document.body
            body.style.backgroundColor = ''
            next()
        },
    }
</script>
