package com.oscar.module.crawl;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.google.common.io.Files;
import com.oscar.base.util.FileUtils;

import java.io.File;
import java.io.IOException;
import java.nio.charset.Charset;
import java.util.List;
import java.util.concurrent.TimeUnit;

public class Crawl2050Img {

    public static void main (String[] args) throws IOException, InterruptedException {
        final Crawl2050Img crawl2050 = new Crawl2050Img();
        crawl2050.process();
    }

    private void process () throws IOException, InterruptedException {
        StringBuilder sb = new StringBuilder();

        final List<String> list = Files.readLines(new File("D:\\IdeaProjects\\private_job\\2019\\mall\\mall-java\\src\\main\\resources\\txt\\locations"), Charset.forName("utf-8"));
        list.forEach(sb::append);
        
        System.out.println("完成读取");

        JSONObject jsonObject = JSON.parseObject(sb.toString());
        System.out.println("完成解析");

        final JSONArray locations = jsonObject.getJSONArray("locations");
        final JSONArray countries = jsonObject.getJSONArray("countries");
        for (int i = 0; i < locations.size(); i++) {
            final String preview = locations.getJSONObject(i).getString("preview");
            System.out.println("处理"+preview);
            final String fileName = FileUtils.getFileName(preview);
            FileUtils.downloadPicture(preview, new File("E:\\Program Files\\WebServer\\earth\\assets\\preview\\" + fileName));
            locations.getJSONObject(i).put("preview", "http://localhost/earth/assets/preview/" + fileName);

            final Integer country_id = locations.getJSONObject(i).getInteger("country_id");
            for(int j=0;j<countries.size();j++){
                final Integer cid = countries.getJSONObject(j).getInteger("country_id");
                if (cid == country_id) {
                    final String flag = countries.getJSONObject(j).getString("flag");
                    final String flagFileName = FileUtils.getFileName(flag);
                    FileUtils.downloadPicture(flag, new File("E:\\Program Files\\WebServer\\earth\\assets\\flag\\" + flagFileName));
                    countries.getJSONObject(j).put("flag", "http://localhost/earth/assets/flag/" + flagFileName);
                }
            }

            TimeUnit.SECONDS.sleep(3);
        }

        final String s = JSON.toJSONString(jsonObject);
        Files.write(s.getBytes(),new File("D:\\IdeaProjects\\private_job\\2019\\mall\\mall-java\\src\\main\\resources\\txt\\locations-new"));
    }
}

