package com.oscar.module.crawl;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.oscar.base.util.FileUtils;
import org.springframework.web.bind.annotation.*;

import java.io.*;

@RestController
@RequestMapping("/backend/api/v1")
@CrossOrigin
public class KabasijiController {

    @GetMapping("get")
    public JSONObject get () throws IOException {
        return getJsonObject(FileUtils.readResources("txt/get"));
    }

    @GetMapping("brief/top")
    public JSONObject top () throws IOException {
        return getJsonObject(FileUtils.readResources("txt/top"));
    }

    @GetMapping("location/{pathId}")
    public JSONObject location109 (@PathVariable String pathId) throws IOException {
        return getJsonObject(FileUtils.readResources("txt/" + pathId));
    }

    @GetMapping("localization")
    public JSONObject localization () throws IOException {
        return getJsonObject(FileUtils.readResources("txt/localization"));
    }
    @GetMapping("locations")
    public JSONObject locations () throws IOException {
        return getJsonObject(FileUtils.readResources("txt/locations"));
    }
    @GetMapping("user")
    public String user () {
        return "not logged in";
    }

    private JSONObject getJsonObject (String response) {
        JSONObject jsonObject = JSON.parseObject(response);
        return jsonObject;
    }

}
