package com.oscar.module.crawl;

import cn.hutool.core.io.FileTypeUtil;
import cn.hutool.core.io.FileUtil;
import cn.hutool.core.io.file.FileWriter;
import com.oscar.base.util.FileUtils;
import org.springframework.stereotype.Service;

import java.io.File;
import java.util.List;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

public class MarkdownProcess {
    public static void main(String[] args){
//        newUrl("![1572752233935](.\\assets\\1572752233935.png)");
        start("D:\\Program Files\\wanglei_notebook");
    }


    public static void start(String path){
//        System.out.println(path);
        final File[] ls = FileUtil.ls(path);
        for (File file : ls) {
            String outputPath = getOutputPath(file);
            StringBuilder newFileContent = new StringBuilder();

            if(".md".equals(FileUtils.getSuffix(file.getName()))){
                final List<String> lines = FileUtil.readLines(file, "utf-8");
                for (String line : lines) {
                    newUrl(line, newFileContent);
//                    if(line.contains("C:\\Users\\oscar\\AppData\\Roaming\\Typora\\typora-user-images")){
//                        System.out.println(file.getAbsolutePath());
//                        break;
//                    }
                }
                FileUtil.writeBytes(newFileContent.toString().getBytes(),new File(outputPath));
            }else if(FileUtil.isDirectory(file)){
                if("assets".equals(file.getName())){
                    FileUtil.copy(file.getAbsolutePath(),getOutputPath(file),true);
                }else{
                    start(file.getAbsolutePath());
                }

            }

        }
    }

    private static String getOutputPath (File file) {
        return file.getAbsolutePath().replaceFirst("wanglei_notebook", "wanglei_markdownX");
    }

    static Pattern pattern = Pattern.compile("\\(.*\\\\assets\\\\.*\\)");
    /**
     * ![image-20200113104540948](.\assets\image-20200113104540948.png)
     /storage/emulated/0/Android/data/com.ryeeeeee.markdownx/files/notes/wanglei_markdownX/assets/xxxxx

     * src=".\assets\android\image-20200413171517417.png"  这种都改
     * ..\assets\tools\image-20200418212644966.png
     */
    public static void newUrl(String url, StringBuilder sb){
        Matcher matcher = pattern.matcher(url);
        if(matcher.find()){
            System.out.println(url);
            String newUrl = url.replaceFirst("\\(.*\\\\assets\\\\","(/storage/emulated/0/Android/data/com.ryeeeeee.markdownx/files/notes/wanglei_markdownX/assets/");
            System.out.println();
            sb.append(newUrl).append("\n");
        }else{
            boolean handle = newUrl1(url,sb);
            if(!handle){
                sb.append(url).append("\n");
            }
        }
    }

    static Pattern pattern1 = Pattern.compile("src=\".*\\\\assets\\\\[^\"]*\"");
    public static boolean newUrl1(String url, StringBuilder sb){
        Matcher matcher = pattern1.matcher(url);
        if(matcher.find()){
            System.out.println(matcher.group());
            String newUrl = matcher.group().replaceFirst("src=\".*\\\\assets\\\\","/storage/emulated/0/Android/data/com.ryeeeeee.markdownx/files/notes/wanglei_markdownX/assets/");
            String storageUrl = newUrl.replaceAll("\\\\","/");
            storageUrl = storageUrl.substring(0,storageUrl.length()-1);
            System.out.println(storageUrl);
            sb.append("![image](").append(storageUrl).append(")\n");
            return true;
        }
        return false;
    }

}
