package com.oscar.module.test.kafka;

import java.util.Arrays;
import java.util.Properties;

/**
 * Desc :
 *
 * @author wl
 * Date:    2019/2/25 16:10
 * @version 1.0
 */
public class ConsumerTest {

    public static void main (String[] args) {
        System.setProperty("java.security.auth.login.config", "D:\\IdeaProjects\\private_job\\2019\\mall\\mall-java\\src\\main\\resources\\kafka_client_jaas.conf");

        Properties props = new Properties();

        props.put("bootstrap.servers", "192.168.131.100:9092");

        props.put("group.id", "group-1");

        props.put("enable.auto.commit", "true");

        props.put("auto.commit.interval.ms", "1000");

        props.put("auto.offset.reset", "earliest");

        props.put("session.timeout.ms", "30000");

        props.put("key.deserializer", "org.apache.kafka.common.serialization.StringDeserializer");

        props.put("value.deserializer", "org.apache.kafka.common.serialization.StringDeserializer");

        props.setProperty("security.protocol", "SASL_PLAINTEXT");

        props.setProperty("sasl.mechanism", "PLAIN");

        KafkaConsumer kafkaConsumer = new KafkaConsumer(props);

        TopicPartition p = new TopicPartition("topic_from_java",0);
        kafkaConsumer.assign(Arrays.asList(p));//指定消费topic的那个分区
//        kafkaConsumer.seekToBeginning(Arrays.asList(p));//指定从topic的分区的头部消费
        kafkaConsumer.seek(p,370);//手动指定消费位置，无法自动负载均衡，所以要手动注册，才能消费

//        kafkaConsumer.subscribe(Arrays.asList("topic_from_java"));
        while (true) {
            ConsumerRecords<String, String> records = kafkaConsumer.poll(1000);
            for (ConsumerRecord<String, String> record : records) {
                System.out.printf("offset = %d, value = %s", record.offset(), record.value());
                System.out.println();
            }

        }
    }
}

