package com.oscar.module.test.kafka;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.kafka.core.KafkaTemplate;
import org.springframework.scheduling.annotation.EnableScheduling;
import org.springframework.stereotype.Component;
import org.springframework.util.concurrent.ListenableFuture;

import java.util.UUID;

/**
 * 每个使用到了 KafkaTemplate 对象的方法都会是一个生产者
 * https://spring.io/projects/spring-kafka
 * @author wl
 * Date:    2019/2/1 9:33
 * @version 1.0
 */
@Component
@EnableScheduling
public class KafkaProducer {
    private final KafkaTemplate kafkaTemplate;

    @Autowired
    public KafkaProducer (KafkaTemplate kafkaTemplate) {
        this.kafkaTemplate = kafkaTemplate;
    }

    /**
     * 每隔55s发一次消息
     */
//    @Scheduled(cron = "00/5 * * * * ?")
    public void send () {
        String message = "wanglei-" + UUID.randomUUID().toString();
        ListenableFuture future = kafkaTemplate.send("topic_from_java", message);
        future.addCallback(o -> System.out.println("消息发送成功：" + message), throwable -> System.out.println("消息发送失败：" + message));

    }
}
