package com.oscar.module.test.kafka.stream;

import org.apache.kafka.clients.producer.KafkaProducer;
import org.apache.kafka.clients.producer.Producer;
import org.apache.kafka.clients.producer.ProducerRecord;

import java.util.Properties;
import java.util.Scanner;

/**
 * Desc : 生产记录，保存到kafka topic
 *
 * @author wl
 * Date:    2019/5/20 11:18
 * @version 1.0
 */
public class SendWord {
    public static final String input_topic = "in_word_topic";
    public static final String output_topic = "output_word_topic";

    public static void main (String[] args) {
        Properties props = new Properties();
        props.put("bootstrap.servers", "ubuntu:9092");
        props.put("acks", "all");//Set acknowledgements for producer requests
        props.put("retries", 3); // If the request fails, the producer can automatically retry
        props.put("batch.size", 16384);// Specify buffer size
        props.put("linger.ms", 1);
        props.put("buffer.memory", 33554432);
        props.put("key.serializer", "org.apache.kafka.common.serialization.StringSerializer");
        props.put("value.serializer", "org.apache.kafka.common.serialization.StringSerializer");

        Producer<Integer, String> producer = new KafkaProducer<>(props);
        Scanner scanner = new Scanner(System.in);
        int times = 0;
        while (scanner.hasNextLine()) {
            String record = scanner.nextLine();
            System.out.println("input:"+record);
            if (record == null || record.equals("exit")) {
                break;
            }
            producer.send(new ProducerRecord(input_topic, "key:"+(times++), record));
        }
        producer.close();
    }
}
