package com.oscar.module.test.kafka.stream;

import org.apache.kafka.clients.consumer.ConsumerRebalanceListener;
import org.apache.kafka.clients.consumer.ConsumerRecord;
import org.apache.kafka.clients.consumer.ConsumerRecords;
import org.apache.kafka.clients.consumer.KafkaConsumer;
import org.apache.kafka.common.TopicPartition;

import java.time.Duration;
import java.util.Arrays;
import java.util.Collection;
import java.util.Properties;

/**
 * Desc : Consumer，消费消息，打印结果
 *
 * @author wl
 * Date:    2019/5/20 11:19
 * @version 1.0
 */
public class ShowResult {
    public static void main (String[] args) {
        Properties props = new Properties();
        props.put("bootstrap.servers", "ubuntu:9092");
        props.put("group.id", "test");
        props.put("enable.auto.commit", "true");
        props.put("auto.commit.interval.ms", "3000");//3S拉取一次消息
        //        props.put("session.timeout.ms", "30000");
        props.put("key.deserializer", "org.apache.kafka.common.serialization.StringDeserializer");
        props.put("value.deserializer", "org.apache.kafka.common.serialization.LongDeserializer");

        final KafkaConsumer<String, Long> consumer = new KafkaConsumer<>(props);

        //订阅主题列表
        consumer.subscribe(Arrays.asList(SendWord.output_topic), new ConsumerRebalanceListener() {

            @Override
            public void onPartitionsRevoked (Collection<TopicPartition> collection) {
            }

            @Override
            public void onPartitionsAssigned (Collection<TopicPartition> collection) {
                //将偏移设置到最开始
                //consumer.seekToBeginning(collection);
            }
        });
        while (true) {
            ConsumerRecords<String, Long> records = consumer.poll(Duration.ofMillis(100));
            for (ConsumerRecord<String, Long> record : records) {
                System.out.printf("Consumer Output ==> offset=%d, kv=['%s','%s']\n", record.offset(), record.key(), record.value());
            }
        }
    }
}
